#macro BlueButton(fWidth,fHeight,fDepth,fRadius,fEdge)
  #local fRibWidth = 1/64;
  #local nRibs    = 20;

  #local fAngle  = asin((fWidth/2-fEdge)/(fRadius-fEdge));
  #local fZ      = (fRadius-fEdge)*cos(fAngle);


  #local oCyl =
    object {
      union {
        cylinder{<0,0,0><0,fHeight,0>,fRadius-fEdge}
        cylinder{<0,fEdge,0><0,fHeight-fEdge,0>,fRadius}
        torus{fRadius-fEdge,fEdge translate (fHeight-fEdge)*y}
        torus{fRadius-fEdge,fEdge translate fEdge*y}
        }
      }
    
  #local oCorner =
    object {
      union {
        sphere{<0,fEdge,0>,fEdge}
        cylinder{<0,fEdge,0><0,fHeight-fEdge,0>,fEdge}
        sphere{<0,fHeight-fEdge,0>,fEdge}
        }
      }  

  #local oRib =
    object {
      box{<-fRibWidth/2,fEdge,-fRibWidth/2>< fRibWidth/2,fHeight-fEdge, fRibWidth/2> rotate 45*y}
      }
        
  #local oBlueButton =
    object {
      difference {
        union {
          intersection {
            object{Wedge(degrees(2*fAngle)) rotate  (180-degrees(fAngle))*y }
            object {oCyl}
            }
          box{<-(fWidth/2-fEdge),0,-fZ>< (fWidth/2-fEdge), fHeight,0>}
          object{oCorner translate <-(fWidth/2-fEdge),0,-fZ>}  
          object{oCorner translate < (fWidth/2-fEdge),0,-fZ>}
          box{<-fWidth/2,fEdge,-fZ><fWidth/2,fHeight-fEdge,0>}
          cylinder{<-(fWidth/2-fEdge),fEdge,-fZ><-(fWidth/2-fEdge),fEdge,0>,fEdge}  
          cylinder{< (fWidth/2-fEdge),fEdge,-fZ>< (fWidth/2-fEdge),fEdge,0>,fEdge}  
          cylinder{<-(fWidth/2-fEdge),fHeight-fEdge,-fZ><-(fWidth/2-fEdge),fHeight-fEdge,0>,fEdge}  
          cylinder{< (fWidth/2-fEdge),fHeight-fEdge,-fZ>< (fWidth/2-fEdge),fHeight-fEdge,0>,fEdge}
          #local iy = 0;
          #while (iy <= nRibs)
            object{oRib translate -fRadius*z rotate -degrees(fAngle-2*fAngle*iy/nRibs)*y}  
            #local iy = iy + 1;
          #end
          }
        cylinder{<0,-0.1,0><0,fHeight+0.1,0>,fRadius-fDepth}  
        }
      }    
      
  oBlueButton
#end
