#macro Bottle(bEmpty)
  #local fBottleRadius = 1+13/32-0.001;
  #local fBottleHeight = 8.5;
  #local fBottleTexture = T_Glass1;
  
  #local fMiddleRadius = 1+13/32;
  #local fMiddleHeight = 2.0; 
  #local fMiddleYOffset = 3.50;
  
  #local oMiddle =
    object {
      union {
        sor {
          4, // # of points
          <fMiddleRadius,-1>, <fMiddleRadius, 0>,<fMiddleRadius,fMiddleHeight>,<fMiddleRadius,fMiddleHeight+1>
          open
          texture{uv_mapping pigment{image_map{jpeg "Bottle"}}}
          }
        sor {
          4, // # of points
          <fMiddleRadius-0.01,-1>, <fMiddleRadius-0.01, 0>,<fMiddleRadius-0.01,fMiddleHeight>,<fMiddleRadius-0.01,fMiddleHeight+1>
          open
          texture{pigment{White}}
          }
        }
      }
      
  #local oBottleGlass =
    object {
      sor {
        13,
        <0,0>,
        <1,0>,
        <1+7/16,1>,
        <1+1/4,1.75>,
        <1+7/16,3.375>,
        <1+13/32,3.5>,
        <1+13/32,5.5>,
        <1+7/16,5.625>,
        <1+5/16,6>,
        <1+3/16,6.5>,
        <1/2,8>,
        <1/2,8.75>,
        <1/2,9>
        }
      texture{fBottleTexture}
      }
      
  #local oCoke =  
    object {
     sor {
       5,
       <0,0.05>,
       <1-.05,0.05>,
       <1+7/16-.05,1>,
       <1+1/4-.05,1.75>,
       <1+7/16-.05,3.375>
       }
     texture{pigment{color red 0.10 green 0.04 blue 0.04} }
     }
     
  #local oBottleCap =
    object {
      cylinder{<0,0,0><0,0.75,0>,19/32}
      pigment{Red}
      }    
      
  #local oBottle =
    object {
      union {
        object {oBottleGlass} 
        #if (bEmpty = false)
          object {oCoke }
        #end  
        object {oMiddle translate fMiddleYOffset*y}
        object {oBottleCap translate 8*y}
        }
      scale 1/12
      }
      
  oBottle
#end