#macro CeilingVent()

  #local fMinWidth  = 2;
  #local fGapWidth  = 1.00;
  #local fHeight    = 0.95;
  #local fThickness = 0.1;
  #local fVents     = 4;
  #local fCeilingVentWidth = (fVents-1)*2*fGapWidth+fMinWidth;
  #local tCeilingVentTexture = texture{pigment{White*0.65}        
                               normal { bumps 0.04 scale 0.0005 } 
                               finish { ambient 0.65 diffuse 0.25 phong 0.5 }               
                               }                                  
  
  #local oVentPrism =
    prism {
      conic_sweep
      linear_spline
      0, // height 1
      1, // height 2
      5, // the number of points making up the shape...
      <1,1>,<-1,1>,<-1,-1>,<1,-1>,<1,1>
      rotate <180, 0, 0>
      translate <0, 1, 0>
      }
  
  #local oVent =
     object {
       union {
         #local i = 0;
         #while (i < fVents)
           #local fWidth = fMinWidth+2*i*fGapWidth;
           object {
             intersection {
               difference {
                 object { oVentPrism scale fWidth}
                 object { oVentPrism scale fWidth translate -fThickness*y}
                 }
               box{<-(fWidth+0.1),-0.1,-(fWidth+0.1)>< (fWidth+0.1),fHeight, (fWidth+0.1)>}
               }  
             }
           #local i = i + 1;
         #end      
         }
       }
    
  #local oVentTile =
    object {
      union {
        difference {
          box{<0,0,0><fCeilingTileWidth*12,fCeilingTileHeight*12,fCeilingTileDepth*12>}
          box{<-fCeilingVentWidth,-0.1,-fCeilingVentWidth><fCeilingVentWidth,fCeilingTileHeight*12+0.1,fCeilingVentWidth> 
            translate<fCeilingTileWidth*12/2,0,fCeilingTileDepth*12/2>
            }
          }
        object {box{<0,fCeilingTileHeight*12,0><fCeilingTileWidth*12,fCeilingTileHeight*12+0.1,fCeilingTileDepth*12> pigment{Black}}}
        object { 
          oVent
          translate <12,-0.125,24>
          texture{tCeilingVentTexture} 
          }  
        }
      texture{vCeilingTileTexture}   
      scale 1/12
      }
  oVentTile
#end
  