#macro FireExt()
  #local fRadius = 3.0;
  #local fHeight = 24.00;
  #local fEdgeRadius = 0.25;
  #local fStemHeight = 1.0;
  #local fStemRadius = 1.00;
  #local tTexture = texture{pigment{Red}
                    finish { phong 0.5 }
                    };
  #local fValveRadius = 0.75;
  #local fValveHeight = 2.00;
  #local fHoseStemWidth = 1.5;
  #local fHoseStemRadius = 0.5;
//  #local tValveTexture = texture{pigment{White*0.75}
//                         finish{phong 0.5}};
  #local tValveTexture = T_Silver_5E;
  #local fHoseWidth1 = 2.00;
  #local fHoseRadius = 0.675;
  #local fHoseBend1Radius = 3.00;
  #local fHoseBend1Angle  = 120;
  #local fHoseBend2Radius = 6.00;
  #local fHoseBend2Angle = 30;
  #local fHoseWidth2 = 2.00;
  #local fHoseConeWidth = 12.00;
  #local fHoseConeRadius = 1.50;
  #local fDialStemRadius = 0.125;
  #local fDialStemDepth  = 0.5;
  #local fDialRadius     = 1.0;
  #local fDialDepth      = 0.125;
  #local fDialBorderRadius = 0.125;
  #local tHoseTexture = pigment{White*0.05};
  #local tDialGlassTexture = T_Glass1;

  #local fHandleThickness   = 0.0625;
  #local fHandleAngle       = 20;
  
  #local fUpperHandle1Width = 3.50;
  #local fUpperHandle2Width = 3.50;
  #local fUpperHandleHeight = 1.00;
  #local fUpperHandleDepth  = 1.50;
  #local fUpperHandleEdgeRadius = 0.125;
  #local fUpperHandleAngle  = 15;
  
  #local fLowerHandle1Width = 3.00;
  #local fLowerHandle2Width = 3.00;
  #local fLowerHandleHeight = 1.00;
  #local fLowerHandleDepth  = fUpperHandleDepth-2*fHandleThickness;
  #local fLowerHandleEdgeRadius = 0.125;
  #local fLowerHandleAngle  = 20;   
  
  #local tHandleTexture = T_Silver_5E;
  
  #local oUpperHandle =
    object {
      union {
        difference {
          object {
            Round_Box(<0,0,0>,<fUpperHandle1Width,fUpperHandleHeight,fUpperHandleDepth>,fUpperHandleEdgeRadius,false)
            }
          object {
            Round_Box(<0,0,fHandleThickness>,<fUpperHandle1Width,fUpperHandleHeight,fUpperHandleDepth-fHandleThickness>,fUpperHandleEdgeRadius,false)
            translate <fHandleThickness,-fHandleThickness,0>
            }
          }
        object {
          difference {
            object {
              Round_Box(<0,0,0>,<fUpperHandle2Width,fUpperHandleHeight,fUpperHandleDepth>,fUpperHandleEdgeRadius,false)
              }
            object {
              Round_Box(<-fHandleThickness,0,fHandleThickness>,<fUpperHandle2Width+fHandleThickness,fUpperHandleHeight,fUpperHandleDepth-fHandleThickness>,fUpperHandleEdgeRadius,false)
              translate <0,-fHandleThickness,0>
              }
            }
          translate <-fHandleThickness,-fUpperHandleHeight+fHandleThickness,0>
          rotate -fUpperHandleAngle*z
          translate <fUpperHandle1Width-2*fHandleThickness,fUpperHandleHeight-fHandleThickness,0>  
          }
        }  
      texture {tHandleTexture}  
      }
  
  #local oLowerHandle =
    object {
      union {
        difference {
          object {
            Round_Box(<0,0,0>,<fLowerHandle1Width,fLowerHandleHeight,fLowerHandleDepth>,fLowerHandleEdgeRadius,false)
            }
          object {
            Round_Box(<0,0,fHandleThickness>,<fLowerHandle1Width,fLowerHandleHeight,fLowerHandleDepth-fHandleThickness>,fLowerHandleEdgeRadius,false)
            translate <fHandleThickness,fHandleThickness,0>
            }
          } 
        object { 
          difference {
            union {  
              object {
                Round_Cylinder(<0,0,0>,<0,0,fLowerHandleDepth>,fLowerHandleHeight/2,fLowerHandleEdgeRadius,false)
                }  
              object {
                Round_Box(<0,0,0>,<fLowerHandle2Width,fLowerHandleHeight,fLowerHandleDepth>,fLowerHandleEdgeRadius,false)
                translate -fLowerHandleEdgeRadius*x
                translate -fLowerHandleHeight/2*y
                }
              }  
            object {
              Round_Box(<-fLowerHandleHeight,0,fHandleThickness>,<fLowerHandle2Width+fHandleThickness,fLowerHandleHeight,fLowerHandleDepth-fHandleThickness>,fLowerHandleEdgeRadius,false)
              translate <fHandleThickness,fHandleThickness-fLowerHandleHeight/2,0>
              }
            }  
          rotate -fLowerHandleAngle*z                                
          translate <fLowerHandle1Width-fLowerHandleEdgeRadius,fLowerHandleHeight/2>
          }  
        }
      texture{tHandleTexture}  
      }
      
  #local oHandle =
    object {
      union {
        object {oUpperHandle}
        object {oLowerHandle rotate -fHandleAngle*z translate <0.0625,-fLowerHandleHeight/2,fHandleThickness>}
        }
      rotate fHandleAngle*z 
      }
      
  #local oHose =
    object {
      union {
        cylinder {<0,0,0><-fHoseWidth1,0,0>,fHoseRadius}
        object {
          union {
            object {
              intersection {
                torus{fHoseBend1Radius,fHoseRadius}
                object {Wedge(fHoseBend1Angle) rotate -fHoseBend1Angle*y}
                }
              }
            object {
              union {
                intersection {
                  torus{fHoseBend2Radius,fHoseRadius}
                  object {Wedge(fHoseBend2Angle)}
                  }
                union {
                  cylinder {<0,0,0><fHoseWidth2,0,0>,fHoseRadius}
                  cone{<0,0,0>,fHoseRadius,<-fHoseConeWidth,0,0>,fHoseConeRadius}
                  translate <-fHoseWidth2,0,fHoseBend2Radius>
                  }
                rotate (180-fHoseBend2Angle)*y
                }
              translate (fHoseBend1Radius+fHoseBend2Radius)*z 
              }  
            rotate fHoseBend1Angle*y      
            }  
          rotate -90*x
          rotate 180*y
          translate <-fHoseWidth1,-fHoseBend1Radius,0>
          }    
        }
      texture {tHoseTexture}
      }

  #local oDial =
    object {
      union {
        cylinder {<0,0,0><0,0,-fDialStemDepth>,fDialStemRadius}
        cylinder {<0,0,0><0,0,-fDialDepth>,fDialRadius translate -fDialStemDepth*z}
        torus{fDialRadius-fDialBorderRadius, fDialBorderRadius rotate 90*x translate -(fDialStemDepth+fDialDepth)*z}
        sphere{<0,0,0>,fDialRadius clipped_by{plane{z,0}} scale <1,1,0.125> translate -(fDialStemDepth+fDialDepth)*z texture{tDialGlassTexture}}
        }
      }

  #local oValve = 
    object {
      union {
        cylinder{<0,0,0><0,fValveHeight,0>,fValveRadius}
        object {
          union {
            cylinder{<0,0,0><-fHoseStemWidth,0>,fHoseStemRadius}
            object{oHose translate -(fHoseStemWidth-0.25)*x}
            object{oDial translate -fValveRadius*z}
            object{oHandle translate <-1.5,fValveHeight-0.5,-fUpperHandleDepth/2>}  
            }
          translate fValveHeight*0.5*y
          }
        }
      texture {tValveTexture}
      }

  #local oBody =
    object {
      union {
        Round_Cylinder(<0,0,0>,<0,fHeight,0>,fRadius,fEdgeRadius,false)
        sphere{<0,0,0>,fRadius scale <1,0.5,1> translate (fHeight-fEdgeRadius)*y}
        cylinder {<0,0,0><0,fStemHeight,0>,fStemRadius translate (fHeight+0.5*fRadius-fStemHeight)*y}
        object {oValve translate (fHeight+0.5*fRadius)*y}
        }
      texture{tTexture}
      scale 1/12
      }
  oBody
#end