#include "Puller.inc"

#macro IBM2914Button(sText1,sText2,sText3,bLines,tColor)
  #local fButtonWidth = 1.0;
  #local fButtonHeight = 0.75;
  #local fButtonDepth  = 1.0;
  #local fButtonLineHeight = 0.02;
  #local fButtonLineYOffset = 0.1;
  #local oText1 =
    object {
      text {
        ttf
        "crystal.ttf",
        sText1,        
        0.2,              
        0               
        }
      scale 0.125
      }
  #local oText2 =
    object {
      text {
        ttf
        "crystal.ttf",
        sText2,        
        0.2,              
        0               
        }
      scale 0.125
      }
  #local oText3 =
    object {
      text {
        ttf
        "crystal.ttf",
        sText3,        
        0.2,              
        0               
        }
      scale 0.125
      }
      
  #local oButtonBase =
    object {
      box{<0,0,0><fButtonWidth,fButtonHeight,fButtonDepth>}
      }
      
  #local fText1Width  = max_extent(oText1).x;  
  #local fText1Height = max_extent(oText1).y;  
  #local fText2Width  = max_extent(oText2).x;  
  #local fText2Height = max_extent(oText2).y;  
  #local fText3Width  = max_extent(oText3).x;  
  #local fText3Height = max_extent(oText3).y;
  
  #local nLines = 0;                   
  #local fTextHeight = 0.0;
  #if (strlen(sText1) > 0)
    #local nLines = nLines + 1;
    #local fTextHeight = fTextHeight + fText1Height;
    #if (strlen(sText2) > 0)
      #local nLines = nLines + 1;
      #local fTextHeight = fTextHeight + fText1Height;
      #if (strlen(sText3) > 0)
        #local nLines = nLines + 1;
        #local fTextHeight = fTextHeight + fText1Height;
      #end  
    #end  
  #end
  #local fTextGap = ((fButtonHeight-2*fButtonLineYOffset*bLines)-fTextHeight)/(nLines+1); 
  #debug concat("fTextHeight=",str(fTextHeight,8,4),", fTextGap=",str(fTextGap,8,4),"\n") 
  
  #switch(nLines)
    #case (1)
      #local fText3YOffset = 0.0;
      #local fText2YOffset = 0.0;
      #local fText1YOffset = fButtonLineYOffset*bLines+fTextGap;
    #break
    #case (2)
      #local fText3YOffset = 0.0;
      #local fText2YOffset = fButtonLineYOffset*bLines+fTextGap;
      #local fText1YOffset = fText2YOffset+fText2Height+fTextGap;
    #break
    #case (3)
      #local fText3YOffset = fButtonLineYOffset*bLines+fTextGap;
      #local fText2YOffset = fText3YOffset+fText3Height+fTextGap;
      #local fText1YOffset = fText2YOffset+fText2Height+fTextGap;
    #break
  #end
  
  #local oLine =                      
    object {
      box {<0,-fButtonLineHeight/2,0><fButtonWidth,fButtonLineHeight/2,0.1>}
      }
        
  #local oButton =
    object {
      union {
        object {oButtonBase}
        #if (bLines)
          object {oLine translate <0,fButtonLineYOffset,-0.001> pigment{tColor}}
          object {oLine translate <0,fButtonHeight-fButtonLineYOffset,-0.001> pigment{tColor}}
        #end
        #if (strlen(sText1) > 0)    
          object {oText1 translate <(fButtonWidth-fText1Width)/2,fText1YOffset,-0.001> pigment{tColor}}
        #end  
        #if (strlen(sText2) > 0)    
          object {oText2 translate <(fButtonWidth-fText2Width)/2,fText2YOffset,-0.001> pigment{tColor}}    
        #end  
        #if (strlen(sText3) > 0)    
          object {oText3 translate <(fButtonWidth-fText3Width)/2,fText3YOffset,-0.001> pigment{tColor}}    
        #end  
        }
//      scale <fButtonWidth,fButtonHeight,fButtonDepth>
      }
  oButton  
#end

#macro IBM2914()
  #local fWidth = 40.00;
  #local fHeight = 40.00;
  #local fDepth = 25.25;
  #local fRadius = 0.0625;
  #local fPanelWidth = 0.5;
  #local fPanelGap   = 0.25;
  #local fControlWidth = 38.00;
  #local fControlHeight = 10.75;
  #local fControlDepth = 11.5;
  #local fControlPanelDepth = 2;
  #local fControlXOffset = (fWidth-fControlWidth)/2;
  #local fControlZOffset = (fDepth-fControlDepth-1);
  #local fControlPanelZOffset = 1;
  #local fTopHeight = 1.0;
  #local tFrontTexture = texture{pigment{rgb < 0, 0.15,0.6>}      
                         normal { bumps 0.1 scale 0.0005 }
                         finish { phong 0.5 }              
                         };                                 
  #local tSideTexture  = texture{pigment{White*0.05}      
                         normal { bumps 0.04 scale 0.0005 }
                         finish { phong 0.5 }              
                         };
  #local tTopTexture   = texture{pigment{White*0.9}      
                         normal { bumps 0.04 scale 0.0005 }
                         finish { phong 0.5 }              
                         };
  #local tControlTexture   = texture{pigment{rgb < 218/256, 214/256,165/256>}      
                         normal { bumps 0.04 scale 0.0005 }
                         finish { phong 0.5 }              
                         };
  #local fDialRadius = 1.0;
  #local fDialDepth = 0.250;
  #local fKnobRadius = 7/16;
  #local fKnobInnerRadius = 6/16;
  #local fKnobDepth = 1.25;
  #local tDialTexture = T_Glass1;
  #local tKnobTexture = pigment{White*0.5};
  #local tKnobInnerTexture = pigment{White*0.05};
  #local fControlPanel1Width = 10.5;
  #local fControlPanel2Width = 10.5;
  #local fControlPanel3Width = 10.1875;
  #local fControlPanel4Width = 5.5;
  #local fControlPanelHeight = fControlHeight;
  #local fControlPanelDepth  = 0.125;
  #local tControlPanelTexture = pigment{White*0.7};
  #local fButtonWidth = 1.0;
  #local fButtonHeight = 0.75;
  #local fButtonDepth  = 1.0;
  #local fButtonZOffset = -0.125;
  #local tButtonTexture = pigment{White};
  #local tButtonTexture = T_Glass2;
  #local tRedButtonTexture = T_Ruby_Glass;
  #local fLightRadius = 3/16;
  #local fLightDepth = 0.125;
  #local fLightXOffset = 1.00;
  #local fLightYOffset = 2.5;
  #local fLightYSpace = (8.75-fLightYOffset)/7;
  #local sDialText = array[10];
  #local sDialText[0] = "OFF";
  #local sDialText[1] = "RMT";
  #local sDialText[2] = "8";
  #local sDialText[3] = "7";
  #local sDialText[4] = "6";
  #local sDialText[5] = "5";
  #local sDialText[6] = "4";
  #local sDialText[7] = "3";
  #local sDialText[8] = "2";
  #local sDialText[9] = "1";
  #local oLight =
    object {
      union {
        cylinder{<0,0,0><0,0,-fLightDepth>,fLightRadius pigment{DarkBrown}}
        sphere  {<0,0,0>,fLightRadius*0.75 scale -0.25*z translate -fLightDepth*z texture{T_Glass2}}
        }
      }
  #local oButtonHole =
    object {
      box{<-1/32,-1/32,-1/32><fButtonWidth+1/32,fButtonHeight+1/32,fButtonDepth+1/32>}
      }
//  #local oButton =
//    object {
//      box{<0,0,0><fButtonWidth,fButtonHeight,fButtonDepth>}
//      box{<0,0,0><1,1,1>}
//      }
  #local oDial =
    object {
      union {
        cylinder{<0,0,0><0,0,-fDialDepth>,fDialRadius texture{tDialTexture}}
        #local i = 0;
        #while(i < 10)
          #local oText = text{ttf "ariblk" sDialText[i] 1,<0,0,0>};
          #local fTextWidth = max_extent(oText).x;
          object {
            oText
            translate -fTextWidth/2*x
            scale <0.15,0.15,0.01>
            translate 0.75*y
            rotate -36*i*z
            pigment{White}
            }
          #local i = i + 1;
        #end
        cylinder{<0,0,0><0,0,-fKnobDepth>,fKnobRadius texture{tKnobTexture}}
        cylinder{<0,0,0><0,0,-fKnobDepth-0.01>,fKnobInnerRadius texture{tKnobInnerTexture}}
        }
      }
  #local oControlPanel1 =
    object {
      union {
        difference {
          box{<0,0,0><fControlPanel1Width,fControlPanelHeight,fControlPanelDepth>}
          object {oButtonHole translate <1.25+0*7/3,5.5,0>}
          object {oButtonHole translate <1.25+0*7/3,7.0,0>}
          object {oButtonHole translate <1.25+1*7/3,5.5,0>}
          object {oButtonHole translate <1.25+1*7/3,7.0,0>}
          object {oButtonHole translate <1.25+2*7/3,5.5,0>}
          object {oButtonHole translate <1.25+2*7/3,7.0,0>}
          object {oButtonHole translate <1.25+3*7/3,5.5,0>}
          object {oButtonHole translate <1.25+3*7/3,7.0,0>}
          }
        object {IBM2914Button("A"    ,"ACTIVE","",true,Black) translate <1.25+0*7/3,5.5,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("Valid","Select","",true,Black) translate <1.25+0*7/3,7.0,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("B"    ,"ACTIVE","",true,Black) translate <1.25+1*7/3,5.5,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("Valid","Select","",true,Black) translate <1.25+1*7/3,7.0,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("C"    ,"ACTIVE","",true,Black) translate <1.25+2*7/3,5.5,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("Valid","Select","",true,Black) translate <1.25+2*7/3,7.0,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("D"    ,"ACTIVE","",true,Black) translate <1.25+3*7/3,5.5,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("Valid","Select","",true,Black) translate <1.25+3*7/3,7.0,fButtonZOffset> texture{tButtonTexture}}
        object {oDial translate <1.75,      3.875,-0.0625>}
        object {oDial translate <1.75+  7/3,3.875,-0.0625>}
        object {oDial translate <1.75+2*7/3,3.875,-0.0625>}
        object {oDial translate <1.75+3*7/3,3.875,-0.0625>}
        }
      texture{tControlPanelTexture}
      }
  #local oControlPanel2 =
    object {
      union {
        difference {
          box{<0,0,0><fControlPanel2Width,fControlPanelHeight,fControlPanelDepth>}
          object {oButtonHole translate <1.25,5.5,0>}
          object {oButtonHole translate <1.25,7.0,0>}
          object {oButtonHole translate <1.25+1*7/3,5.5,0>}
          object {oButtonHole translate <1.25+1*7/3,7.0,0>}
          object {oButtonHole translate <1.25+2*7/3,5.5,0>}
          object {oButtonHole translate <1.25+2*7/3,7.0,0>}
          object {oButtonHole translate <1.25+3*7/3,5.5,0>}
          object {oButtonHole translate <1.25+3*7/3,7.0,0>}
          }
        object {IBM2914Button("E","ACTIVE","",true,Black) translate <1.25,5.5fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("Valid","Select","",true,Black) translate <1.25,7.0,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("F","ACTIVE","",true,Black) translate <1.25+1*7/3,5.5,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("Valid","Select","",true,Black) translate <1.25+1*7/3,7.0,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("G","ACTIVE","",true,Black) translate <1.25+2*7/3,5.5,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("Valid","Select","",true,Black) translate <1.25+2*7/3,7.0,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("H","ACTIVE","",true,Black) translate <1.25+3*7/3,5.5,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("Valid","Select","",true,Black) translate <1.25+3*7/3,7.0,fButtonZOffset> texture{tButtonTexture}}
        object {oDial translate <1.75,      3.875,-0.0625>}
        object {oDial translate <1.75+  7/3,3.875,-0.0625>}
        object {oDial translate <1.75+2*7/3,3.875,-0.0625>}
        object {oDial translate <1.75+3*7/3,3.875,-0.0625>}
        }
      texture{tControlPanelTexture}
      }
  #local oControlPanel3 =
    object {
      union {
          box{<0,0,0><fControlPanel3Width,fControlPanelHeight,fControlPanelDepth>}
        }
      texture{tControlPanelTexture}
      }
  #local oControlPanel4 =
    object {
      union {
        difference {
          box{<0,0,0><fControlPanel4Width,fControlPanelHeight,fControlPanelDepth>}
          object {oButtonHole translate<1.875,fLightYOffset+1*fLightYSpace-fButtonHeight/2,0>}
          object {oButtonHole translate<3.375,fLightYOffset+1*fLightYSpace-fButtonHeight/2,0>}
          object {oButtonHole translate<1.875,fLightYOffset+5*fLightYSpace-fButtonHeight/2,0>}
          object {oButtonHole translate<3.375,fLightYOffset+5*fLightYSpace-fButtonHeight/2,0>}
          object {oButtonHole translate<1.875,fLightYOffset+7*fLightYSpace-fButtonHeight/2,0>}
          object {oButtonHole translate<3.375,fLightYOffset+7*fLightYSpace-fButtonHeight/2,0>}
          }
        object {IBM2914Button("ALARM","","",false,White) translate<1.875,fLightYOffset+1*fLightYSpace-fButtonHeight/2,fButtonZOffset> texture{tRedButtonTexture}}
        object {IBM2914Button("AUDIBLE","ALARM","RESET",false,White) translate<3.375,fLightYOffset+1*fLightYSpace-fButtonHeight/2,fButtonZOffset> pigment{Blue} }
        object {IBM2914Button("I/O POWER","SEQUENCE","COMPLETE",true,Black) translate<1.875,fLightYOffset+5*fLightYSpace-fButtonHeight/2,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("","","",false,Black) translate<3.375,fLightYOffset+5*fLightYSpace-fButtonHeight/2,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("POWER","ON","",false,Black) translate<1.875,fLightYOffset+7*fLightYSpace-fButtonHeight/2,fButtonZOffset> texture{tButtonTexture}}
        object {IBM2914Button("PWR OFF","IF IN","LOCAL",false,White) translate<3.375,fLightYOffset+7*fLightYSpace-fButtonHeight/2,fButtonZOffset> pigment{Red} }
        #local n = 0;
        #while(n < 8)
          object {oLight translate <fLightXOffset,fLightYOffset+n*fLightYSpace,0>}
          object {text{ttf "ariblk.ttf" str(8-n,1,0) 0.2,0} pigment{White*0.1} scale 0.33 translate <fLightXOffset-0.0625,fLightYOffset+n*fLightYSpace+0.25,-0.001>}
          #local n = n + 1;
        #end
        object {text{ttf "ariblk.ttf" "CHAN INTF" 0.2,0} pigment{White*0.1} scale <0.20,0.25,1> translate <fLightXOffset-0.75,fLightYOffset+8*fLightYSpace-0.000,-0.001>}
        object {text{ttf "ariblk.ttf" "ACTIVE"    0.2,0} pigment{White*0.1} scale <0.20,0.25,1> translate <fLightXOffset-0.50,fLightYOffset+8*fLightYSpace-0.250,-0.001>}
        }
      texture{tControlPanelTexture}
      }
  #local oControlPanel =
    object {
      union {
        object {oControlPanel1 translate  1/16*x}
        object {oControlPanel2 translate (1/16+fControlPanel1Width+1/16)*x}
        object {oControlPanel3 translate (1/16+fControlPanel1Width+1/16+fControlPanel2Width+1/16)*x}
        object {oControlPanel4 translate (1/16+fControlPanel1Width+1/16+fControlPanel2Width+1/16+fControlPanel3Width+1/16)*x}
        }
      }
  #local oCore =
    object {
      box{<0,0,0><fWidth-2*fPanelWidth,fHeight-fTopHeight,fDepth-2*fPanelWidth>}
      }
  #local oSidePanel =
    object {
      Round_Box(<0,0,0>,<fPanelWidth,fHeight-fTopHeight-fPanelGap,fDepth>,fRadius,false)
      texture{tSideTexture}
      }
  #local oFrontDoor =
    object {
      Round_Box(<0,0,0>,<(fWidth-2*fPanelWidth-3*fPanelGap)/2,fHeight-fTopHeight-fPanelGap,fPanelWidth>,fRadius,false)
      texture{tFrontTexture}
      }
  #local oTop =
    object {
      box{<0,0,0><fWidth,fTopHeight,fDepth>}
      texture{tTopTexture}
      }
  #local oCase =
    object {
      union {
        object {oCore translate <fPanelWidth,0,fPanelWidth>}
        object {oSidePanel}
        object {oSidePanel translate (fWidth-fPanelWidth)*x}
        object {oFrontDoor translate <(fPanelWidth+fPanelGap),0,0>}
        object {oFrontDoor translate <(fPanelWidth+fPanelGap),0,fDepth-fPanelWidth>}
        object {oFrontDoor translate <(fWidth+fPanelGap)/2,0,0>}
        object {oFrontDoor translate <(fWidth+fPanelGap)/2,0,fDepth-fPanelWidth>}
        object {oTop       translate <0,fHeight-fTopHeight,0>}
        }
      }
  #local oControlCore =
    object {
      box{<0,0,0><fControlWidth-2*fPanelWidth,fControlHeight-fPanelWidth,fControlDepth-fPanelWidth-fControlPanelZOffset>}
      }
  #local oControlSide =
    object {
      Round_Box(<0,0,0>,<fPanelWidth,fControlHeight-fPanelWidth,fControlDepth>,fRadius,false)
      texture{tControlTexture}
      }
  #local oControlBack =
    object {
      Round_Box(<0,0,0>,<fControlWidth-2*(fPanelWidth+fPanelGap),fControlHeight-fPanelWidth-fPanelGap,fPanelWidth>,fRadius,false)
      texture{tControlTexture}
      }
  #local oControlTop =
    object {
      Round_Box(<0,0,0>,<fControlWidth,fPanelWidth,fControlDepth>,fRadius,false)
      texture{tControlTexture}
      }
  #local oControl =
    object {
      union {
        object {oControlCore translate<fPanelWidth,0,fControlPanelZOffset>}
        object {oControlSide}
        object {oControlSide translate (fControlWidth-fPanelWidth)*x}
        object {oControlBack translate (fControlDepth-fPanelWidth)*z}
        object {oControlTop  translate (fControlHeight-fPanelWidth)*y}
        object {oControlPanel rotate 2.5*x translate <fPanelWidth,0,0.25>}
        object {Puller() rotate 15*y translate <fControlWidth*0.5,fControlHeight,fControlDepth*0.5>}
        }
      }
      
  #local o2914 =
    object {
      union {
        object {oCase}
        object {oControl translate <fControlXOffset,fHeight,fControlZOffset>}
        }
      scale 1/12
      }
  o2914
#end
