#macro IBM3290(sImage) 
  #local fWidth   = 21.00;
  #local fHeight  = 18.00;
  #local fDepth   =  4.00;
  #local fCorner  =  0.75;
  #local fEdge    =  0.125;
  #local tTexture     =  texture {
                        pigment{rgb <0.85,0.85,0.65>}                   //* Base Texture                        */
                        normal { bumps 0.04 scale 0.0005 }
                        finish { phong .5 }
                        }
  
  #local fCenterWidth = 16.00;
  #local fCenterHeight = 14.00;
  #local fCenterDepth  =  1.00;
  #local fCenterCorner = 0.50;
  #local fCenterEdge   = 0.125;
  #local fCenterXOffset = (fWidth-fCenterWidth)/2;                       
  #local fCenterYOffset = (fHeight-fCenterHeight)/2;                       
  #local fCenterZOffset = -0.125;                       
  #local tCenterTexture = pigment{Tan*0.5};
                         
  #local fFrameWidth = 14.00;
  #local fFrameHeight = 12.00;
  #local fFrameDepth  =  1.00;
  #local fFrameCorner = 0.50;
  #local fFrameEdge   = 0.125;
  #local fFrameXOffset = (fWidth-fFrameWidth)/2;                       
  #local fFrameYOffset = (fHeight-fFrameHeight)/2;                       
  #local fFrameZOffset = -0.250;                       
  #local tFrameTexture = pigment{Tan*0.5};
                         
  #local fHoleWidth  = 13.75;
  #local fHoleHeight = 11.75;
  #local fHoleDepth  =  2.00;
  #local fHoleCorner = 0.375;
  #local fHoleEdge   = 0.125;
  #local fHoleXOffset = (fWidth-fHoleWidth)/2;                       
  #local fHoleYOffset = (fHeight-fHoleHeight)/2;                       
  #local fHoleZOffset = -0.50;                       
  #local tHoleTexture = pigment{Tan*0.5};

  #local fDisplayWidth   = 14.00;
  #local fDisplayHeight  = 12.00;
  #local fDisplayDepth   =  0.5;
  #local fDisplayXOffset = (fWidth-fDisplayWidth)/2;                       
  #local fDisplayYOffset = (fHeight-fDisplayHeight)/2;                       
  #local fDisplayZOffset = 0;                       
  #local tDisplayTexture = pigment{Black};

  #local fStandRadius = 0.375;
  #local fStandBend   = 1.00;
  #local fStandLeg1  = 4.0;
  #local fStandLeg2  = 9.0;
  #local fStandLeg3  = 3.0;
  #local fStandLeg4  = 6.0;
  #local fStandLeg5  = 8.0;
                            
  #local fHingeRadius = 1.0;                            
                               
  #local oStandElbow  =
    object {
      intersection {
        torus{fStandBend,fStandRadius}
        Wedge(90)
        }
      }
                                     
  #local oHinge =
    object {
      union {
        cylinder{<0,0,0><0,0,fHingeRadius/2>,fStandRadius+0.0625}
        sphere  {<0,0,0>,                    fStandRadius+0.0625}
        cylinder {<0,0,0><-1,0,0>,           fStandRadius+0.0625}
        box{<-1,-(fStandRadius+0.0625),0><0,(fStandRadius+0.0625),fHingeRadius/2>}
        object {
          Round_Cylinder(<-1,0,0>,<0,0,0>,fHingeRadius,0.0625,false)
          translate -(fStandRadius+0.0625)*x
          }
        }
      texture{tCenterTexture}
      }
      
  #local oStandRight =
    object {
      union {
        object {oHinge}
        cylinder{<0,0,0><0,0,fStandLeg1>,fStandRadius translate <0,0,0>} 
        object {oStandElbow rotate 90*z translate <0,-fStandBend,fStandLeg1>}
        cylinder{<0,0,0><0,-fStandLeg2,0>,fStandRadius translate <0,-fStandBend,fStandLeg1+fStandBend>}
        object {oStandElbow rotate 90*x translate <-fStandBend,-fStandBend-fStandLeg2,fStandLeg1+fStandBend>} 
        cylinder{<0,0,0><-fStandLeg3,0,0>,fStandRadius translate <-fStandBend,-2*fStandBend-fStandLeg2,fStandLeg1+fStandBend>}
        object {oStandElbow rotate -90*y translate <-fStandBend-fStandLeg3,-2*fStandBend-fStandLeg2,fStandLeg1>}
        cylinder{<0,0,0><0,0,-fStandLeg4>,fStandRadius translate <-2*fStandBend-fStandLeg3,-2*fStandBend-fStandLeg2,fStandLeg1>}
        object {oStandElbow rotate 90*y translate <-3*fStandBend-fStandLeg3,-2*fStandBend-fStandLeg2,-(fStandLeg4-fStandLeg1)>}
        cylinder{<0,0,0><-fStandLeg5,0,0>,fStandRadius translate <-3*fStandBend-fStandLeg3,-2*fStandBend-fStandLeg2,-fStandBend-(fStandLeg4-fStandLeg1)>}
        }
      }  
      
  #local oStandLeft =
    object {
      union {
        object {oHinge rotate 180*z}
        cylinder{<0,0,0><0,0,fStandLeg1>,fStandRadius translate <0,0,0>} 
        object {oStandElbow rotate 90*z translate <0,-fStandBend,fStandLeg1>}
        cylinder{<0,0,0><0,-fStandLeg2,0>,fStandRadius translate <0,-fStandBend,fStandLeg1+fStandBend>}
        object {oStandElbow rotate 90*x rotate 180*y translate < fStandBend,-fStandBend-fStandLeg2,fStandLeg1+fStandBend>} 
        cylinder{<0,0,0>< fStandLeg3,0,0>,fStandRadius translate < fStandBend,-2*fStandBend-fStandLeg2,fStandLeg1+fStandBend>}
        object {oStandElbow  translate < fStandBend+fStandLeg3,-2*fStandBend-fStandLeg2,fStandLeg1>}
        cylinder{<0,0,0><0,0,-fStandLeg4>,fStandRadius translate < 2*fStandBend+fStandLeg3,-2*fStandBend-fStandLeg2,fStandLeg1>}
        object {oStandElbow rotate 180*y translate < 3*fStandBend+fStandLeg3,-2*fStandBend-fStandLeg2,-(fStandLeg4-fStandLeg1)>}
        cylinder{<0,0,0>< fStandLeg5,0,0>,fStandRadius translate < 3*fStandBend+fStandLeg3,-2*fStandBend-fStandLeg2,-fStandBend-(fStandLeg4-fStandLeg1)>}
        }
      }  
      
  
                    
  #local oStand =
    object {
      union {
        object {oStandLeft  translate -(fWidth/2+0.125+0.0625+fStandRadius)*x}
        object {oStandRight translate  (fWidth/2+0.125+0.0625+fStandRadius)*x}
        }
      texture{tTexture}  
      }
                           
                         
  #local oMonitorCase =
    object {
      union{
        object {
          Round_Cylinder(<0,0,0>,<0,0,fDepth>,fCorner,fEdge,false)
          translate <fCorner,fCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fDepth>,fCorner,fEdge,false)
          translate <fWidth-fCorner,fCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fDepth>,fCorner,fEdge,false)
          translate <fCorner,fHeight-fCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fDepth>,fCorner,fEdge,false)
          translate <fWidth-fCorner,fHeight-fCorner,0>
          }                                           
        object {
          Round_Box(<0,fCorner-fEdge,0>,<fWidth,fHeight-fCorner+fEdge,fDepth>,fEdge,false)
          }
        object {
          Round_Box(<fCorner-fEdge,0,0>,<fWidth-fCorner+fEdge,fHeight,fDepth>,fEdge,false)
          }
        object {
          Round_Box(<2.0,2.0,fDepth-fEdge>,<fWidth-2.0,fHeight-2.0,fDepth+3.0>,fEdge,false)
          texture{tCenterTexture}
          }
        }
      texture{tTexture}
      }
      
  #local oMonitorCenter =
    object {
      union{
        object {
          Round_Cylinder(<0,0,0>,<0,0,fCenterDepth>,fCenterCorner,fCenterEdge,false)
          translate <fCenterCorner,fCenterCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fCenterDepth>,fCenterCorner,fCenterEdge,false)
          translate <fCenterWidth-fCenterCorner,fCenterCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fCenterDepth>,fCenterCorner,fCenterEdge,false)
          translate <fCenterCorner,fCenterHeight-fCenterCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fCenterDepth>,fCenterCorner,fCenterEdge,false)
          translate <fCenterWidth-fCenterCorner,fCenterHeight-fCenterCorner,0>
          }                                           
        object {
          Round_Box(<0,fCenterCorner-fEdge,0>,<fCenterWidth,fCenterHeight-fCenterCorner+fEdge,fCenterDepth>,fCenterEdge,false)
          }
        object {
          Round_Box(<fCenterCorner-fEdge,0,0>,<fCenterWidth-fCenterCorner+fEdge,fCenterHeight,fCenterDepth>,fCenterEdge,false)
          }
        }
      texture{tCenterTexture}
      }
      
  #local oMonitorFrame =
    object {
      union{
        object {
          Round_Cylinder(<0,0,0>,<0,0,fFrameDepth>,fFrameCorner,fFrameEdge,false)
          translate <fFrameCorner,fFrameCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fFrameDepth>,fFrameCorner,fFrameEdge,false)
          translate <fFrameWidth-fFrameCorner,fFrameCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fFrameDepth>,fFrameCorner,fFrameEdge,false)
          translate <fFrameCorner,fFrameHeight-fFrameCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fFrameDepth>,fFrameCorner,fFrameEdge,false)
          translate <fFrameWidth-fFrameCorner,fFrameHeight-fFrameCorner,0>
          }                                           
        object {
          Round_Box(<0,fFrameCorner-fEdge,0>,<fFrameWidth,fFrameHeight-fFrameCorner+fEdge,fFrameDepth>,fFrameEdge,false)
          }
        object {
          Round_Box(<fFrameCorner-fEdge,0,0>,<fFrameWidth-fFrameCorner+fEdge,fFrameHeight,fFrameDepth>,fFrameEdge,false)
          }
        }
      texture{tFrameTexture}
      }
      
  #local oMonitorHole =
    object {
      union{
        object {
          Round_Cylinder(<0,0,0>,<0,0,fHoleDepth>,fHoleCorner,fHoleEdge,false)
          translate <fHoleCorner,fHoleCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fHoleDepth>,fHoleCorner,fHoleEdge,false)
          translate <fHoleWidth-fHoleCorner,fHoleCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fHoleDepth>,fHoleCorner,fHoleEdge,false)
          translate <fHoleCorner,fHoleHeight-fHoleCorner,0>
          }
        object {
          Round_Cylinder(<0,0,0>,<0,0,fHoleDepth>,fHoleCorner,fHoleEdge,false)
          translate <fHoleWidth-fHoleCorner,fHoleHeight-fHoleCorner,0>
          }                                           
        object {
          Round_Box(<0,fHoleCorner-fEdge,0>,<fHoleWidth,fHoleHeight-fHoleCorner+fEdge,fHoleDepth>,fHoleEdge,false)
          }
        object {
          Round_Box(<fHoleCorner-fEdge,0,0>,<fHoleWidth-fHoleCorner+fEdge,fHoleHeight,fHoleDepth>,fHoleEdge,false)
          }
        }
      texture{tHoleTexture}
      }
      

      
  #local oMonitorDisplay =
    object {
      box{<0,0,0><1,1,1>}
      pigment{image_map{jpeg concat("Keyboard/",sImage)}}
      scale <fDisplayWidth,fDisplayHeight,fDisplayDepth> 
      }
      
  #local oMonitor =
    object {
      union {
        object {
          union {
            difference {
              union {
                object { oMonitorCase }
                object { oMonitorCenter translate <fCenterXOffset,fCenterYOffset,fCenterZOffset>}
                object { oMonitorFrame  translate <fFrameXOffset ,fFrameYOffset ,fFrameZOffset >}
                }
              object { oMonitorHole translate <fHoleXOffset ,fHoleYOffset ,fHoleZOffset >} 
              object {
                box{<-0.1,-0.1,0><fWidth+0.1,fHeight+0.1,0.125>}
                translate (fDepth/2-0.0625)*z
                }
              object {
                union {
                  cylinder{<-0.1,0,0><0.125,0,0>,fHingeRadius+0.0625 }
                  cylinder{<-0.125,0,0><0.1,0,0>,fHingeRadius+0.0625 translate fWidth*x}
                  }
                translate <0,fHeight/2,fDepth/2>  
                }
              }
            object {
              union {
                cylinder{<0,0,0><0,0,0.125>,fCorner-0.125 translate <fCorner,fCorner,0>}
                cylinder{<0,0,0><0,0,0.125>,fCorner-0.125 translate <fWidth-fCorner,fCorner,0>}
                cylinder{<0,0,0><0,0,0.125>,fCorner-0.125 translate <fCorner,fHeight-fCorner,0>}
                cylinder{<0,0,0><0,0,0.125>,fCorner-0.125 translate <fWidth-fCorner,fHeight-fCorner,0>}
                box{<0.125,fCorner,0><fWidth-0.125,fHeight-fCorner,0.125>}
                box{<fCorner,0.125,0><fWidth-fCorner,fHeight-0.125,0.125>}
                }
              translate (fDepth/2-0.0625)*z
              texture {tTexture}
              }
            object { oMonitorDisplay translate <fDisplayXOffset ,fDisplayYOffset ,fDisplayZOffset >}
            }
          translate <0,-fHeight/2,-fDepth/2>
          rotate 5*x  
          translate <0, fHeight/2, fDepth/2>
          }
        object { oStand translate <(fWidth/2),fHeight/2,fDepth/2>}  
        }
      translate ((-fHeight/2)+(fStandBend+fStandLeg2+fStandBend+fStandRadius))*y
      scale 1/12
      }  
      
  oMonitor
#end