// Persistence of Vision Ray Tracer Scene Description File
// File: ?.pov
// Vers: 3.5
// Desc: Basic Scene Example
// Date: mm/dd/yy
// Auth: ?
//

#declare fIBM3494Radius   =  0.0625;
#declare fIBM3494Width    = 28.000;
#declare fIBM3494Height   = 67.875;
#declare fIBM3494Depth1   = 25.750;
#declare fIBM3494Depth2   = 29.000;
#declare fIBM3494DepthGap =  0.250;
#declare fIBM3494EndWidth =  0.500;

#declare fIBM3494WindowWidth   =  0.125;
#declare fIBM3494WindowHeight  = 53.875;
#declare fIBM3494WindowDepth   = 13.875;
#declare fIBM3494WindowXOffset =  2*fIBM3494Radius;
#declare fIBM3494WindowYOffset =  7.000;
#declare fIBM3494WindowZOffset =  6.000; 

#declare fIBM3494Texture1      = texture {
                                  pigment{White*0.05}                   //* Base Texture                        */
                                  normal { bumps 0.04 scale 0.0005 }
                                  finish { phong .5 }
                                  };
#declare fIBM3494Texture2      = texture {
                                  pigment{White*0.80}                   //* Base Texture                        */
                                  normal { bumps 0.04 scale 0.0005 }
                                  finish { phong .5 }
                                  };
#declare fIBM3494Texture3           = T_Chrome_5E;
//#declare fIBM3494Texture1      =  T_Glass1;
//#declare fIBM3494Texture2      =  T_Glass1;

#declare fIBM3494DoorWidth          = 29.000;
#declare fIBM3494DoorHeight         = 67.875;
#declare fIBM3494DoorDepth          =  2.000;
#declare fIBM3494DoorVent1Width     = 22.875;
#declare fIBM3494DoorVent1Height    = 11.000;
#declare fIBM3494DoorVent1nSlat     = 15;
#declare fIBM3494DoorVent1XOffset   =  2.875;
#declare fIBM3494DoorVent1YOffset   = 49.875;
#declare fIBM3494DoorVent2Width     = 22.875;
#declare fIBM3494DoorVent2Height    = 11.000/3;
#declare fIBM3494DoorVent2nSlat     =  5;
#declare fIBM3494DoorVent2XOffset   =  2.875;
#declare fIBM3494DoorVent2YOffset   = 35.000;
#declare fIBM3494DoorVent3Width     = 22.875;
#declare fIBM3494DoorVent3Height    = 11.000;
#declare fIBM3494DoorVent3nSlat     = 15;
#declare fIBM3494DoorVent3XOffset   =  2.875;
#declare fIBM3494DoorVent3YOffset   = 15.500;
#declare fIBM3494DoorVent4Width     = 22.875;
#declare fIBM3494DoorVent4Height    = 11.000;
#declare fIBM3494DoorVent4nSlat     = 15;
#declare fIBM3494DoorVent4XOffset   =  2.875;
#declare fIBM3494DoorVent4YOffset   =  4.500;
#declare fIBM3494DoorPCInsetWidth   = 22.875;
#declare fIBM3494DoorPCInsetHeight  = 17.250;
#declare fIBM3494DoorPCInsetDepth   =  9.000;
#declare fIBM3494DoorPCInsetXOffset =  2.875;
#declare fIBM3494DoorPCInsetYOffset = 43.625;
#declare fIBM3494DoorPCInsetZOffset = 22.875;

#declare fIBM3494LockBaseRadius     =  9/16;
#declare fIBM3494LockCapRadius      =  7/16;
#declare fIBM3494LockDepth          =  0.250;
#declare fIBM3494LockXOffset        = fIBM3494DoorWidth-2.500;
#declare fIBM3494LockYOffset        = 32.000;

#declare fIBM3494Hinge1YOffset      = 60.750;
#declare fIBM3494Hinge2YOffset      = 15.500;
#declare fIBM3494Hinge1Height       =  7.125;
#declare fIBM3494Hinge2Height       = 30.375;
#declare fIBM3494HingeHeight        = 14.875;
#declare fIBM3494HingeRadius        =  0.625;

#declare fIBM3494HandleWidth        =  4.375;
#declare fIBM3494HandleHeight       =  6.375;
#declare fIBM3494HandleXOffset      = 20.500;
#declare fIBM3494HandleYOffset      = 33.500;
#declare fIBM3494HandleRadius       =  0.375;

#declare fIBM3494ExtendedWidth      =  8.375;
#declare fIBM3494ExtendedHeight     = 27.500;
#declare fIBM3494ExtendedDepth      =  0.750;
#declare fIBM3494ExtendedXOffset    =  7.750;
#declare fIBM3494ExtendedYOffset    = 17.375;
#declare fIBM3494ExtendedLeftWidth  =  0.500;
#declare fIBM3494ExtendedLeftLength =  1.625;
#declare fIBM3494ExtendedRightWidth  =  0.500;
#declare fIBM3494ExtendedRightLength =  1.625;
#declare fIBM3494ExtendedCylRadius    = 3.2;
#declare fIBM3494ExtendedCylHeight    = fIBM3494ExtendedHeight-2*fIBM3494Radius;
#declare fIBM3494ExtendedCylXOffset   = fIBM3494ExtendedWidth/2;
#declare fIBM3494ExtendedCylYOffset   = fIBM3494Radius;
#declare fIBM3494ExtendedCylZOffset   = 3.5;
#declare fIBM3494ExtendedCylWindowWidth =   2.00;
#declare fIBM3494ExtendedCylWindowHeight = fIBM3494ExtendedHeight-2.00; 
#declare fIBM3494ExtendedCylWindowRadius =  0.25;

#declare fIBM3494ConvenienceWidth   = 11.750;
#declare fIBM3494ConvenienceHeight  = 14.875;
#declare fIBM3494ConvenienceDepth   =  0.750;
#declare fIBM3494ConvenienceXOffset =  4.375;
#declare fIBM3494ConvenienceYOffset = 45.875;
#declare fIBM3494ConvenienceLeftWidth  =  3.875;
#declare fIBM3494ConvenienceLeftLength =  1.625;
#declare fIBM3494ConvenienceRightWidth  =  0.500;
#declare fIBM3494ConvenienceRightLength =  1.625;
#declare fIBM3494ConvenienceCylRadius    = 3.2;
#declare fIBM3494ConvenienceCylHeight    = fIBM3494ConvenienceHeight-2*fIBM3494Radius;
#declare fIBM3494ConvenienceCylXOffset   = fIBM3494ConvenienceWidth-fIBM3494ExtendedWidth/2;
#declare fIBM3494ConvenienceCylYOffset   = fIBM3494Radius;
#declare fIBM3494ConvenienceCylZOffset   = 3.5;
#declare fIBM3494ConvenienceCylWindowWidth  =   2.00;
#declare fIBM3494ConvenienceCylWindowHeight = fIBM3494ConvenienceHeight-2.00; 
#declare fIBM3494ConvenienceCylWindowRadius =  0.25;
#declare fIBM3494ConveniencePanelWidth   = 2.8125;
#declare fIBM3494ConveniencePanelHeight  = 13.625;
#declare fIBM3494ConveniencePanelDepth   =  0.0625;
#declare fIBM3494ConveniencePanelXOffset = 0.625;
#declare fIBM3494ConveniencePanelYOffset = 0.625;

#declare fIBM3494BlueButtonWidth    = 1.500;
#declare fIBM3494BlueButtonHeight   = 0.500;
#declare fIBM3494BlueButtonDepth    = 0.375;
#declare fIBM3494BlueButtonRadius   = 0.0625;
  
#declare fIBM3494PowerPanelWidth         = 2.8125;            //* 2 13/16
#declare fIBM3494PowerPanelHeight        = 2.5000;
#declare fIBM3494PowerPanelDepth         = fIBM3494Radius;
#declare fIBM3494PowerPanelXOffset       = 0.5000;
#declare fIBM3494PowerPanelYOffset       = 11.7500;
#declare tIBM3494PowerPanelTexture       = pigment{White*0.2}
#declare fIBM3494PowerPanelSwitchXOffset = 0.2500;
#declare fIBM3494PowerPanelSwitchYOffset = 0.2500;
#declare fIBM3494PowerPanelSwitchZOffset =-0.03125;
#declare fIBM3494PowerTextPanelWidth     = 1.25000+1;
#declare fIBM3494PowerTextPanelHeight    = 1.75000;
#declare fIBM3494PowerTextPanelDepth     = 0.01000;
#declare fIBM3494PowerTextPanelXOffset   = 1.25000-1;
#declare fIBM3494PowerTextPanelYOffset   = 0.25000;
#declare fIBM3494PowerTextPanelZOffset    = -0.00010;
#declare fIBM3494PowerTextIXOffset        =  0.25000+1;
#declare fIBM3494PowerTextIYOffset        =  1.25000;
#declare fIBM3494PowerTextIZOffset        = -0.00010;
#declare fIBM3494PowerTextOXOffset        =  0.25000+1;
#declare fIBM3494PowerTextOYOffset        =  0.25000;
#declare fIBM3494PowerTextOZOffset        = -0.00010;

#declare fIBM3494PowerTextUnitWidth       =  1.25000;
#declare fIBM3494PowerTextUnitXOffset     =  fIBM3494PowerPanelSwitchXOffset;
#declare fIBM3494PowerTextUnitYOffset     =  2.12500;
#declare fIBM3494PowerTextUnitZOffset     = -0.00010;

#declare fIBM3494ConvenienceTextPowerWidth        =  1.00000;
#declare fIBM3494ConvenienceTextPowerXOffset      = fIBM3494PowerPanelSwitchXOffset;
#declare fIBM3494ConvenienceTextPowerYOffset      = 10.87500;
#declare fIBM3494ConvenienceTextPowerZOffset      = -0.00010;

#declare fIBM3494ConvenienceTextControlWidth      =  1.00000;
#declare fIBM3494ConvenienceTextControlXOffset    = fIBM3494PowerPanelSwitchXOffset;
#declare fIBM3494ConvenienceTextControlYOffset    =  6.50000;
#declare fIBM3494ConvenienceTextControlZOffset    = -0.00010;

#declare fIBM3494ConvenienceTextStatusWidth       =  1.00000;
#declare fIBM3494ConvenienceTextStatusXOffset     = fIBM3494PowerPanelSwitchXOffset;
#declare fIBM3494ConvenienceTextStatusYOffset     =  3.62500;
#declare fIBM3494ConvenienceTextStatusZOffset     = -0.00010;

//*************************************************************************************************************/
//* Front Panel Definitions (Logo)                                                                            */
//*************************************************************************************************************/ 
#declare fLogoWidth        =  2.500;
#declare fLogoHeight       =  1.750;
#declare fLogoDepth        =  0.0625;
#declare fLogoXOffset      = fIBM3494DoorWidth -6.625;
#declare fLogoYOffset      = fIBM3494DoorHeight-8.875;
#declare fIBMWidth         =  1.70;
#declare fIBMHeight        =  0.75;
#declare fIBMDepth         = 1/32;
#declare fIBMAngle         = 30;
#declare fIBMXOffset       =  0.45;
#declare fIBMYOffset       =  0.225;
#declare f3494XOffset      =  1.70;
#declare f3494YOffset      =  0.45;

//#declare nFrames = 10; 
//#declare nFrames =  1; 

#include "BarCode.inc"
#include "IBM3490Cart.inc"
#include "IBM3494PowerPanel.inc"
#include "IBM3494ConveniencePanel.inc"
#include "IBM3494Frame.inc"

#macro IBM3494(maxFrames)
  #local nFrames = max(5,maxFrames);
  #local oIBM3494 =
    object {                   
      union {
        #local iFrame = 0;
        #while (iFrame < nFrames)
          object {
//            union {                             
              #switch (iFrame)
                #case (0)                      //* First Frame -- Add End Cover
                  object {IBM3494Frame(1,1,1)}
                #break
                #case (1)                      //* Middle Frame -- Library Manager 
                  object {IBM3494Frame(0,2,2)}
                #break
                #case (nFrames-2)                      //* Last Frame -- Add End Cover
                  object {IBM3494Frame(0,0,0)}
                #break
                #case (nFrames-1)                      //* Last Frame -- Add End Cover
                  object {IBM3494Frame(2,2,3)}
                #break
                #else                          //* Middle Frame -- No End Cover
                  object {IBM3494Frame(0,1,0)}
                #break
              #end
//              } 
            translate iFrame*(fIBM3494EndWidth+fIBM3494Width+fIBM3494EndWidth)*x  
            }  
          #local iFrame = iFrame + 1;
        #end
        }
      scale 1/12
      }
  oIBM3494
#end      