#include "PushButton.inc"
#include "IBM3494Toggle.inc"
#macro IBM3494ConveniencePanel()
  #local tSwitchTexture =  texture{pigment{White*0.2} finish{reflection 0.1 phong 0.3 phong_size 60}};
  #local oPowerText =
    object {
      text { ttf "arial.ttf" "Unit Power" 0.125, <0,0,0>}
      scale <1,1,0.1>
      pigment{White}
      }
  #local fPowerTextWidth = max_extent(oPowerText).x;
  #local fPowerTextScale = fIBM3494ConvenienceTextPowerWidth/fPowerTextWidth;

  #local oControlText =
    object {
      text { ttf "arial.ttf" "Motion Control" 0.125, <0,0,0>}
      scale <1,1,0.1>
      pigment{White}
      }
      
  #local oStatusText =
    object {
      text { ttf "arial.ttf" "I/O Status" 0.125, <0,0,0>}
      scale <1,1,0.1>
      pigment{White}
      }
      
  #local oTextBox =
    object {
      box {<0,0,0>,<1.50,0.60, 0.001>}
      pigment{White*0.6}
      }

  #local oPushButton =
    object {
      union {
        object {
          difference {
            cylinder {<0,0,0><0, 0.1,0>,0.35}
            cylinder {<0,-0.1,0><0, 0.2,0>,0.305}
            }
          pigment{White*0.2}
          }
        object {
          PushButton(0.3,0.05,1,0.1)
          }
        }
      rotate -90*x
      } 
      
  #local fLEDWidth         = 0.325;
  #local fLEDHeight        = 0.075;
  #local oLEDHole =
    object {
      box {<-0.01,-0.01,-0.1><fLEDWidth+0.01,fLEDHeight+0.01,0.1>}
      }
      
  #local oLED =
    object {
      box {<0.00, 0.00,0.00><fLEDWidth,fLEDHeight,-0.001>}
      }
      
  #local oBasePanel =
    object {
      union {
        object {
          IBM3494PowerPanel()
          translate <0,fIBM3494ConveniencePanelHeight-fIBM3494PowerPanelHeight,0>
          }
        union {  
          box{
            <-fIBM3494Radius,-fIBM3494Radius,0>
            <fIBM3494ConveniencePanelWidth+fIBM3494Radius,fIBM3494ConveniencePanelHeight-fIBM3494PowerPanelHeight+fIBM3494Radius,fIBM3494ConveniencePanelDepth>
            }
          object {
            oPowerText
            scale fPowerTextScale
            translate<fIBM3494ConvenienceTextPowerXOffset,fIBM3494ConvenienceTextPowerYOffset,fIBM3494ConvenienceTextPowerZOffset>
            }
          object {
            union {
              object {
                union {
                  object {IBM3494Toggle() translate <-12/16,0.3,0> texture{tSwitchTexture}}
                  box {<0,0,0>,<1.50,0.60, 0.001> pigment{White*0.6}}
                  object {
                    text { ttf "arial.ttf" "Power On" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.1875,0.400,-0.0001>
                    pigment{White}
                    }
                  object {
                    text { ttf "arial.ttf" "Power Off" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.1875,0.100,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.50,fIBM3494ConvenienceTextPowerYOffset-1*0.80,fIBM3494ConvenienceTextPowerZOffset>
                }    
              object {
                union {
                  difference {
                    box {<0,0,0>,<1.50,0.60, 0.001> pigment{White*0.6}}
                    object {oLEDHole translate <0.0625,0.450,0.00>}
                    }
                  object {oLED translate <0.0625,0.450,0> pigment{Green}}
                  object {
                    text { ttf "arial.ttf" "Rack Power Ready" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.0625,0.250,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.50,fIBM3494ConvenienceTextPowerYOffset-2*0.80,fIBM3494ConvenienceTextPowerZOffset>
                }    
              object {
                union {
                  difference {
                    box {<0,0,0>,<1.50,0.60, 0.001> pigment{White*0.6}}
                    object {oLEDHole translate <0.0625,0.450,0.00>}
                    }
                  object {oLED translate <0.0625,0.450,0> pigment{Green}}
                  object {
                    text { ttf "arial.ttf" "System Power Ready" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.0625,0.250,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.50,fIBM3494ConvenienceTextPowerYOffset-3*0.80,fIBM3494ConvenienceTextPowerZOffset>
                pigment{White*0.6}
                }    
              object {
                union {
                  difference {
                    box {<0,0,0>,<1.50,0.60, 0.001> pigment{White*0.6}}
                    object {oLEDHole translate <0.0625,0.450,0.00>}
                    }
                  object {oLED translate <0.0625,0.450,0> pigment{Green*0.1}}
                  object {
                    text { ttf "arial.ttf" "Power Off Pending" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.0625,0.250,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.50,fIBM3494ConvenienceTextPowerYOffset-4*0.80,fIBM3494ConvenienceTextPowerZOffset>
                }    
              object {
                union {
                  object {IBM3494Toggle() translate <-12/16,0.3,0> texture{tSwitchTexture}}
                  box {<0,0,0>,<1.50,0.60, 0.001> pigment{White*0.6}}
                  object {
                    text { ttf "arial.ttf" "Local" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.1875,0.400,-0.0001>
                    pigment{White}
                    }
                  object {
                    text { ttf "arial.ttf" "Remote" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.1875,0.100,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.50,fIBM3494ConvenienceTextPowerYOffset-5*0.80,fIBM3494ConvenienceTextPowerZOffset>
                }    
              }
            }
          object {
            oControlText
            scale fPowerTextScale
            translate<fIBM3494ConvenienceTextControlXOffset,fIBM3494ConvenienceTextControlYOffset,fIBM3494ConvenienceTextControlZOffset>
            }
          object {
            union {
              object {
                union {
                  object {oPushButton translate < 0.000,  0.300, 0.000> pigment{SkyBlue}}
                  difference {
                    box {<0,0,0>,<1.80,0.60, 0.001> pigment{White*0.6}}
                    object {oLEDHole translate <0.3625,0.450,0.00>}
                    }
                  object {oLED translate <0.3625,0.450,0> pigment{Green}}
                  object {
                    text { ttf "arial.ttf" "Auto" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.3625,0.250,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.80,fIBM3494ConvenienceTextControlYOffset-1*0.80,fIBM3494ConvenienceTextPowerZOffset>
                }    
              object {
                union {
                  object {oPushButton translate < 0.000,  0.300, 0.000> pigment{Orange}}
                  difference {
                    box {<0,0,0>,<1.80,0.60, 0.001> pigment{White*0.6}}
                    object {oLEDHole translate <0.3625,0.450,0.00>}
                    }
                  object {oLED translate <0.3625,0.450,0> pigment{Green*0.1}}
                  object {
                    text { ttf "arial.ttf" "Pause" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.3625,0.250,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.80,fIBM3494ConvenienceTextControlYOffset-2*0.80,fIBM3494ConvenienceTextPowerZOffset>
                }    
              object {
                union {
                  difference {
                    box {<0,0,0>,<1.50,0.60, 0.001> pigment{White*0.6}}
                    object {oLEDHole translate <0.0625,0.450,0.00>}
                    }
                  object {oLED translate <0.0625,0.450,0> pigment{Green*0.1}}
                  object {
                    text { ttf "arial.ttf" "Intervention" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.0625,0.250,-0.0001>
                    pigment{White}
                    }
                  object {
                    text { ttf "arial.ttf" "Required" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.0625,0.100,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.50,fIBM3494ConvenienceTextControlYOffset-3*0.80,fIBM3494ConvenienceTextPowerZOffset>
                }
              }
            }    
          object {
            oStatusText
            scale fPowerTextScale
            translate<fIBM3494ConvenienceTextStatusXOffset,fIBM3494ConvenienceTextStatusYOffset,fIBM3494ConvenienceTextStatusZOffset>
            }
          object {
            union {
              object {
                union {
                  difference {
                    box {<0,0,0>,<1.50,0.60, 0.001> pigment{White*0.6}}
                    object {oLEDHole translate <0.0625,0.450,0.00>}
                    }
                  object {oLED translate <0.0625,0.450,0> pigment{Green*0.1}}
                  object {
                    text { ttf "arial.ttf" "Input Mode" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.0625,0.250,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.50,fIBM3494ConvenienceTextStatusYOffset-1*0.80,fIBM3494ConvenienceTextPowerZOffset>
                }    
              object {
                union {
                  difference {
                    box {<0,0,0>,<1.50,0.60, 0.001> pigment{White*0.6}}
                    object {oLEDHole translate <0.0625,0.450,0.00>}
                    }
                  object {oLED translate <0.0625,0.450,0> pigment{Green*0.1}}
                  object {
                    text { ttf "arial.ttf" "Output Mode" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.0625,0.250,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.50,fIBM3494ConvenienceTextStatusYOffset-2*0.80,fIBM3494ConvenienceTextPowerZOffset>
                }    
              object {
                union {
                  difference {
                    box {<0,0,0>,<1.50,0.60, 0.001> pigment{White*0.6}}
                    object {oLEDHole translate <0.0625,0.450,0.00>}
                    }
                  object {oLED translate <0.0625,0.450,0> pigment{Green*0.1}}
                  object {
                    text { ttf "arial.ttf" "Unload Required" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.0625,0.250,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.50,fIBM3494ConvenienceTextStatusYOffset-3*0.80,fIBM3494ConvenienceTextPowerZOffset>
                }    
              object {
                union {
                  difference {
                    box {<0,0,0>,<1.50,0.60, 0.001> pigment{White*0.6}}
                    object {oLEDHole translate <0.0625,0.450,0.00>}
                    }
                  object {oLED translate <0.0625,0.450,0> pigment{Green*0.1}}
                  object {
                    text { ttf "arial.ttf" "I/O Locked" 0.125, <0,0,0>}
                    scale <1/7,1/6,1>
                    translate <0.0625,0.250,-0.0001>
                    pigment{White}
                    }
                  }
                translate<fIBM3494ConveniencePanelWidth-0.3125-1.50,fIBM3494ConvenienceTextStatusYOffset-4*0.80,fIBM3494ConvenienceTextPowerZOffset>
                }
              }
            }
          }  
        }
      }
      
  #local oConveniencePanel =
    object {
      oBasePanel
      texture {tIBM3494PowerPanelTexture}
      }
      
  oConveniencePanel
#end