#include "Switchs.inc"
#macro IBM3494PowerPanel()
  #local oUnitText =
    object {
      text { ttf "arial.ttf" "Unit Emergency" 0.125, <0,0,0>}
      scale <1,1,0.1>
      pigment{White}
      }
  #local fUnitTextWidth = max_extent(oUnitText).x;
  #local fUnitTextScale = fIBM3494PowerTextUnitWidth/fUnitTextWidth;
  
  #local oIText =
    object {
      text { ttf "arial.ttf" "I" 0.125, <0,0,0>}
      scale <1/3,1/3,0.1>
      pigment{White}
      }
  #local fITextWidth = max_extent(oIText).x;
  
  #local oOText =
    object {
      text { ttf "arial.ttf" "O" 0.125, <0,0,0>}
      scale <1/3,1/3,0.1>
      pigment{White}
      }
  #local fOTextWidth = max_extent(oOText).x;
  
  #local oTextPanel =
    object {
      union {
        box{<0,0,0><fIBM3494PowerTextPanelWidth,fIBM3494PowerTextPanelHeight,fIBM3494PowerTextPanelDepth>}
        object {
          oIText
          translate <fIBM3494PowerTextIXOffset-fITextWidth/2,fIBM3494PowerTextIYOffset,fIBM3494PowerTextIZOffset>  
          }
        object {
          oOText
          translate <fIBM3494PowerTextOXOffset-fOTextWidth/2,fIBM3494PowerTextOYOffset,fIBM3494PowerTextOZOffset>  
          }
        }
      pigment{White*0.6}
      }
      
  #local oBasePanel =
    object {
      union {
        box{
          <-fIBM3494Radius,-fIBM3494Radius,0>
          <fIBM3494PowerPanelWidth+fIBM3494Radius,fIBM3494PowerPanelHeight+fIBM3494Radius,fIBM3494PowerPanelDepth>
          }
        object {
          oUnitText
          scale <fUnitTextScale,fUnitTextScale,1>
          translate <fIBM3494PowerTextUnitXOffset,fIBM3494PowerTextUnitYOffset,fIBM3494PowerTextUnitZOffset>  
          }
        object {
          oTextPanel
          translate <fIBM3494PowerTextPanelXOffset,fIBM3494PowerTextPanelYOffset,fIBM3494PowerTextPanelZOffset>  
          }
        }
      }
      
  #local oPowerPanel =
    object {
      union {
        object {
          difference {
            object {oBasePanel}
            object {RedSwitchHole(3/128) translate <fIBM3494PowerPanelSwitchXOffset,fIBM3494PowerPanelSwitchYOffset,0>}
            }
          }
        object {
          RedSwitch()
          translate <fIBM3494PowerPanelSwitchXOffset,fIBM3494PowerPanelSwitchYOffset,fIBM3494PowerPanelSwitchZOffset>
          }
        }    
      texture {tIBM3494PowerPanelTexture}
      }
      
  oPowerPanel
#end