#macro IBM3494Toggle()
  #local fToggleRadius    =  0.300;
  #local fToggleWidth     =  0.65625;
  #local fToggleCorner    =  0.025;

  #local oHalfToggle =
    object {
      union {
        intersection {
          object { Round_Cylinder(< 0, 0, 0>,< fToggleWidth, 0, 0>, fToggleRadius, fToggleCorner, true) }
          box{< -0.01, -(fToggleRadius+0.01), 0>< fToggleWidth+0.01, +(fToggleRadius+0.01), (fToggleRadius+0.01)>}
          }
        box{ < fToggleCorner,-(fToggleRadius-fToggleCorner),0>< fToggleWidth-fToggleCorner, (fToggleRadius-fToggleCorner), -fToggleCorner>}
        cylinder{< fToggleCorner, -(fToggleRadius-fToggleCorner), 0>< fToggleCorner, +(fToggleRadius-fToggleCorner), 0>,fToggleCorner}  
        cylinder{< fToggleWidth-fToggleCorner, -(fToggleRadius-fToggleCorner), 0>< fToggleWidth-fToggleCorner, +(fToggleRadius-fToggleCorner), 0>,fToggleCorner}
        cylinder{< fToggleCorner,-(fToggleRadius-fToggleCorner),0><fToggleWidth-fToggleCorner,-(fToggleRadius-fToggleCorner),0>,fToggleCorner}
        cylinder{< fToggleCorner, (fToggleRadius-fToggleCorner),0><fToggleWidth-fToggleCorner, (fToggleRadius-fToggleCorner),0>,fToggleCorner}
        sphere{<fToggleCorner,-(fToggleRadius-fToggleCorner), 0>,fToggleCorner}  
        sphere{<fToggleWidth-fToggleCorner,-(fToggleRadius-fToggleCorner), 0>,fToggleCorner}  
        sphere{<fToggleCorner, (fToggleRadius-fToggleCorner), 0>,fToggleCorner}  
        sphere{<fToggleWidth-fToggleCorner, (fToggleRadius-fToggleCorner), 0>,fToggleCorner}  
        }
      }
      
  #local oToggleBox =
    object {
      union {
        box{<0,0      , 0.03125>< 0.0625,0.6        ,-0.03125>}
        box{<0,0.03125,0>< 0.0625,0.6-0.03125,-0.06250>} 
        cylinder{<0,0.03125,-0.03125><0.0625,0.03125,-0.03125>,0.03125}
        cylinder{<0,0.03125,-0.03125><0.0625,0.03125,-0.03125>,0.03125 translate <0,0.6-0.0625,0>}
        }
      }
   
      
  #local oToggle =
    object {
      union {
        object {oToggleBox translate <0,-0.3,0>}
        object {oHalfToggle rotate   0*x translate <0.0625+0.015625,0,0>}
        object {oHalfToggle rotate  20*x translate <0.0625+0.015625,0,0>}
        object {oToggleBox translate <0.0625+0.015625+fToggleWidth+0.015625,-0.3,0>}
        }
      }
  oToggle
#end
      
