#macro IBMBook(fDepth,sTitle1,sTitle2,sNumber)
  #local fRadius = 1/16;
  
  #local oOS390 =
    object {
      text{ ttf "times.ttf" "z/OS" 1, <0,0,0>}
      scale < .25, 0.25, 0.001>
      pigment{Black}
      }
       
  #local oTitle1 =
    object {
      text{ ttf "times.ttf" sTitle1 1, <0,0,0>}
      scale < .45, 0.45, 0.001>
      pigment{Black}
      }
      
  #local oTitle2 =
    object {
      text{ ttf "times.ttf" sTitle2 1, <0,0,0>}
      scale < .45, 0.45, 0.001>
      pigment{Black}
      }
      
  #local oNumber =
    object {
      text{ ttf "tahoma.ttf" sNumber 1, <0,0,0>}
      scale < .125, 0.125, 0.001>
      pigment{Black}
      }
       
  #local oSplineText1 =
    object{
      text {ttf "tahoma" "z/OS" 1, <0,0,0>}
      scale <0.25,0.25,0.001>
      pigment{Black}
      }
       
  #local fSplineText1XOffset = 1.375;
  #local fSplineText1YOffset = (fDepth-max_extent(oSplineText1).y)/2;
  #local sTitle = sTitle1;
  #if (strlen(sTitle2) > 0)
    #local sTitle = concat(sTitle1,", ",sTitle2);
  #end
       
  #local oSplineText2 =
    object{
      text {ttf "tahoma" sTitle 1, <0,0,0>}
      scale <0.25,0.25,0.001>
      pigment{Black}
      } 
      
  #local fSplineText2XOffset = 3.90;
  #local fSplineText2YOffset = (fDepth-max_extent(oSplineText2).y)/2;
       
  #local oSpline =
    object {
      union {
        box {<0,fRadius,0><11,fDepth-fRadius,0.0001>}
        object{
          oSplineText1
          translate < fSplineText1XOffset, fSplineText1YOffset,-0.001>
          }
        object{
          oSplineText2
          translate < fSplineText2XOffset, fSplineText2YOffset,-0.001>
          }
        }
      rotate -90*z  
      rotate  90*y
      translate <0,11,fDepth>
      pigment{White}    
      }   
             
  #local oCover =
    object {
      union {
        object {
          box {<fRadius,0,0>,<8.5,11,-0.0001>}
          pigment{image_map{jpeg "IBMCover"} scale <8.5,11,1>}
          }
        object {
          oOS390
          translate <0.72, 9.53,-0.001>
          }  
        object {
          oTitle1
          translate <0.72, 8.625,-0.001>
          }  
        object {
          oTitle2
          translate <0.72, 8.125,-0.001>
          }  
        object {
          oNumber
          translate <7.35, 0.50,-0.001>
          }  
        }    
      }
      
  #local oBody =
    object {
      union {
        cylinder{<fRadius,0,fRadius><fRadius,11,fRadius>,fRadius}
        cylinder{<fRadius,0,fDepth-fRadius><fRadius,11,fDepth-fRadius>,fRadius}
        box{<0,0,fRadius><fRadius,11,fDepth-fRadius>}
        box{<fRadius,0,0><8.5,11,fDepth>}
        }
      pigment{White}
      }
      
  #local oBook =
    object {
      union {
        object {oBody}    
        object {oCover}
        object {oSpline}
        }
      scale 1/12
      }
  oBook
#end