#include "IBMKeys.inc"

#declare BaseRad    =  0.05;         
#declare BaseLen    = 17.75;
#declare BaseDep    =  5.25;
#declare BaseHgt    =  0.25;
#declare BaseTopLen = 12.50;
#declare BaseTopDep =  1.00;
#declare BaseTopOff =  0.75;

#declare BaseBotRad  = 0.20;
#declare BaseBotRad1 = 6.0;
#declare BaseBotRad2 = BaseBotRad1+BaseHgt-0.05;
#declare BaseBotDep  = 1.25;
#declare BaseBotAng  = degrees(atan((BaseBotDep-BaseBotRad)/BaseBotRad1));

#declare BaseHoleHgt   =  1.000;
#declare BaseHoleRad   =  0.125;

#declare BaseHole1Len  = 11.3125;
#declare BaseHole1Dep  =  3.7500;
#declare BaseHole1OffX =  0.3125;
#declare BaseHole1OffZ =  0.1250;

#declare BaseHole2Len  =  2.3125;
#declare BaseHole2Dep  =  1.5625;
#declare BaseHole2OffX = BaseHole1OffX+BaseHole1Len+1/4;
#declare BaseHole2OffZ = BaseHole1OffZ;

#declare BaseHole3Len  = BaseHole2Len;
#declare BaseHole3Dep  =  1.5625;
#declare BaseHole3OffX = BaseHole1OffX+BaseHole1Len+1/4;
#declare BaseHole3OffZ = BaseHole1OffZ+BaseHole1Dep-BaseHole3Dep;

#declare BaseHole4Len  =  3.0000;
#declare BaseHole4Dep  = BaseHole1Dep;
#declare BaseHole4OffX = BaseHole2OffX+BaseHole2Len+1/4;
#declare BaseHole4OffZ = BaseHole1OffZ;

#declare BaseHole5Len  =  0.7500;
#declare BaseHole5Dep  =  0.8125;
#declare BaseHole5OffX = BaseHole1OffX;
#declare BaseHole5OffZ = BaseHole1OffZ+BaseHole1Dep+0.3125;
 
#declare BaseHole6Len  =  3.0625;
#declare BaseHole6Dep  = BaseHole5Dep;
#declare BaseHole6OffX = BaseHole1OffX+BaseHole1Len-BaseHole6Len;
#declare BaseHole6OffZ = BaseHole5OffZ;
 
#declare BaseHole7Len  = BaseHole6Len;
#declare BaseHole7Dep  = BaseHole5Dep;
#declare BaseHole7OffX = BaseHole6OffX-0.3125-BaseHole7Len;
#declare BaseHole7OffZ = BaseHole5OffZ;
 
#declare BaseHole8Len  = BaseHole6Len;
#declare BaseHole8Dep  = BaseHole5Dep;
#declare BaseHole8OffX = BaseHole7OffX-0.3125-BaseHole8Len;
#declare BaseHole8OffZ = BaseHole5OffZ;
 
#declare BaseHole9Len  = BaseHole3Len;
#declare BaseHole9Dep  = BaseHole5Dep;
#declare BaseHole9OffX = BaseHole3OffX;
#declare BaseHole9OffZ = BaseHole5OffZ;
                 
#declare BaseHole10Len  = BaseHole4Len;
#declare BaseHole10Dep  = BaseHole5Dep;
#declare BaseHole10OffX = BaseHole4OffX;
#declare BaseHole10OffZ = BaseHole5OffZ;

#declare BaseLight1OffX =  0.3125;
#declare BaseLight1OffZ =  0.5000;
#declare BaseLight2OffX =  1.0625;
#declare BaseLight2OffZ =  0.5000;
#declare BaseLight3OffX =  1.8125;
#declare BaseLight3OffZ =  0.5000;
#declare BaseLightHoleRad = 5/32;
#declare BaseLightRad   =  5/64;

                 
#declare BaseGrooveLen =  9.50;
#declare BaseGrooveHgt = BaseHgt/5;
#declare BaseGrooveRad =  1.0625;
#declare BaseGrooveOffX = BaseHole2OffX+BaseHole2Len-BaseGrooveLen;
#declare BaseGrooveOffZ = BaseDep+0.250;        

#declare Base_Mid =
  object {
    Round_Box (<0,0,0>,<BaseLen,BaseHgt,BaseDep>,BaseRad,false)
    }
    
#declare Base_Top_M = 
  object {
    Round_Box(<0,0,0>,<BaseTopLen,BaseHgt,BaseTopDep>,BaseRad,false)
    }
    
#declare Base_Top_R =
  object {
    Round_Cylinder(<0,0,0>,<0,BaseHgt,0>,BaseTopOff,BaseRad,false)
    }                                                          
    
#declare Base_Top_L =
  object {
    Round_Box(<0,0,0>,<2*BaseTopOff,BaseHgt,BaseTopDep>,BaseRad,false)
    }
    
#declare Base_Top =
  object {
    union {
      object { Base_Top_M }
      object { Base_Top_R translate <BaseTopLen, 0.0, BaseTopDep-BaseTopOff> }
      object { 
        Base_Top_L
        translate <-(2*BaseTopOff-BaseRad), 0.0, -(BaseTopDep-BaseRad)>
        rotate -45*y
        translate < BaseRad, 0.0, BaseTopDep-BaseRad>
        }
      }
    }

#declare Base_Groove =
  object {
    intersection {
      cylinder { <0,0,0><BaseGrooveLen,0,0>,BaseGrooveRad translate (BaseGrooveRad-BaseGrooveHgt)*y}
      plane{ x,0 rotate -45*z translate BaseGrooveLen*x}
      plane{-x,0 rotate  60*z rotate  45*y translate 0.775*x} 
      }
    }
    
#declare Base_Hole_1 =
  object {
    Round_Box(<0,0,0><BaseHole1Len, BaseHoleHgt, BaseHole1Dep>,BaseHoleRad,false)
    }    
    
#declare Base_Hole_2 =
  object {
    union {
      Round_Box(<0,0,0><BaseHole2Len, BaseHoleHgt, BaseHole2Dep/2>,BaseHoleRad,false)
      object {
        Round_Box(<0,0,0><BaseHole2Len/3, BaseHoleHgt, BaseHole2Dep>,BaseHoleRad,false)
        translate <BaseHole2Len/3,0,0>
        }
      }
    }    
    
#declare Base_Hole_3 =
  object {
    Round_Box(<0,0,0><BaseHole3Len, BaseHoleHgt, BaseHole3Dep>,BaseHoleRad,false)
    }    
    
#declare Base_Hole_4 =
  object {
    Round_Box(<0,0,0><BaseHole4Len, BaseHoleHgt, BaseHole4Dep>,BaseHoleRad,false)
    }    
    
#declare Base_Hole_5 =
  object {
    Round_Box(<0,0,0><BaseHole5Len, BaseHoleHgt, BaseHole5Dep>,BaseHoleRad,false)
    }    
    
#declare Base_Hole_6 =
  object {
    Round_Box(<0,0,0><BaseHole6Len, BaseHoleHgt, BaseHole6Dep>,BaseHoleRad,false)
    }    
    
#declare Base_Hole_7 =
  object {
    Round_Box(<0,0,0><BaseHole7Len, BaseHoleHgt, BaseHole7Dep>,BaseHoleRad,false)
    }    
    
#declare Base_Hole_8 =
  object {
    Round_Box(<0,0,0><BaseHole8Len, BaseHoleHgt, BaseHole8Dep>,BaseHoleRad,false)
    }    
    
#declare Base_Hole_9 =
  object {
    Round_Box(<0,0,0><BaseHole9Len, BaseHoleHgt, BaseHole9Dep>,BaseHoleRad,false)
    }    
    
#declare Base_Hole_10 =
  object {
    box{<0,0,0><BaseHole10Len, BaseHoleHgt, BaseHole10Dep>}
    }

#declare BaseLightLabelBox =
  object {
    box{<0,0,0><1,1,1>}
    }

#declare BaseLightLabelNum =        
  object { 
    BaseLightLabelBox 
    pigment{image_map{gif "Keyboard/num" transmit 13, 1}  }
    scale <0.25,BaseHgt,0.25>    rotate 90*x
    translate BaseHgt*y 
    }
    
#declare BaseLightLabelCaps =        
  object { 
    BaseLightLabelBox 
    pigment{image_map{gif "Keyboard/caps" transmit 13, 1}  }
    scale <0.25,BaseHgt,0.25>    rotate 90*x
    translate BaseHgt*y 
    }
    
#declare BaseLightLabelLock =        
  object { 
    BaseLightLabelBox 
    pigment{image_map{gif "Keyboard/lock" transmit 13, 1}  }
    scale <0.25,BaseHgt,0.25>    rotate 90*x
    translate BaseHgt*y 
    }
    
#declare BaseLights =
  object {
    union {
      difference {
        box{<0,0,0><BaseHole10Len, BaseHgt, BaseHole10Dep>}
        object {
          union {
            sphere{<0,0,0>,BaseLightHoleRad translate <BaseLight1OffX,0,BaseLight1OffZ>}
            sphere{<0,0,0>,BaseLightHoleRad translate <BaseLight2OffX,0,BaseLight2OffZ>}
            sphere{<0,0,0>,BaseLightHoleRad translate <BaseLight3OffX,0,BaseLight3OffZ>}
            }
          translate (BaseHgt+BaseLightHoleRad*.707)*y
          }
        }
      object {
        union {
          sphere{<0,0,0>,BaseLightRad translate <BaseLight1OffX,0,BaseLight1OffZ> pigment {Green} finish{ambient 1}}
          sphere{<0,0,0>,BaseLightRad translate <BaseLight2OffX,0,BaseLight2OffZ> pigment{Green*0.1}}
          sphere{<0,0,0>,BaseLightRad translate <BaseLight3OffX,0,BaseLight3OffZ> pigment{Green*0.1}}
          }
        translate (BaseHgt-BaseLightRad*.5)*y
        }
      object { 
        BaseLightLabelNum 
        translate <BaseLight1OffX-0.125,0.0001,BaseLight1OffZ-0.5>       
        }
      object { 
        BaseLightLabelCaps 
        translate <BaseLight2OffX-0.125,0.0001,BaseLight2OffZ-0.5>        
        }
      object { 
        BaseLightLabelLock 
        translate <BaseLight3OffX-0.125,0.0001,BaseLight3OffZ-0.5>        
        }
      }
    }    
    
#declare ibm_logo =
  object {
    box { < 0, 0, 0>< 1.1, BaseHgt+0.001, 0.5>}
    rotate -90*x
    pigment {
      image_map {png "Keyboard/IBM_LOGO_WHITE" transmit 13, 1}
      scale <1.1, 0.5, 1.0>
      }
    rotate  90*x
    }
    
#declare BaseBotCyl =
  object {
    union {
      difference {
        cylinder { < BaseRad,      0.0, 0.0>< BaseLen-BaseRad,      0, 0>,BaseBotRad2 }
        cylinder { < BaseRad-0.01, 0.0, 0.0>< BaseLen-BaseRad+0.01, 0, 0>,BaseBotRad1 }
        }
      difference {
        cylinder { <     0, 0.0, 0.0>< BaseLen,      0, 0>,BaseBotRad2-BaseRad }
        cylinder { < -0.01, 0.0, 0.0>< BaseLen+0.01, 0, 0>,BaseBotRad1+BaseRad }
        }
      torus { BaseBotRad1+BaseRad,BaseRad rotate 90*z translate          BaseRad *x}  
      torus { BaseBotRad2-BaseRad,BaseRad rotate 90*z translate          BaseRad *x}  
      torus { BaseBotRad1+BaseRad,BaseRad rotate 90*z translate (BaseLen-BaseRad)*x}  
      torus { BaseBotRad2-BaseRad,BaseRad rotate 90*z translate (BaseLen-BaseRad)*x}  
      }
    clipped_by { plane {-z, 0 } }
    clipped_by { plane { z, 0 rotate BaseBotAng*x }}  
    }

#declare BaseBotBox =
  object {
    union {
      Round_Box(     <BaseBotRad-BaseRad, 0,-BaseBotRad>,<BaseLen-(BaseBotRad-BaseRad), BaseHgt-0.05, BaseBotRad>, BaseRad,           false)
      Round_Cylinder(<BaseBotRad,         0,          0>,<BaseBotRad,                   BaseHgt-0.05,          0>, BaseBotRad,BaseRad,false)
      Round_Cylinder(<BaseLen-BaseBotRad, 0,          0>,<BaseLen-BaseBotRad,           BaseHgt-0.05,          0>, BaseBotRad,BaseRad,false)
      }
    clipped_by{ plane{ z, 0 } }
    }
    
#declare Base_Bot =
  object {
    union {
      object { BaseBotCyl }
      object { BaseBotBox translate BaseBotRad1*y }
      }
    rotate -BaseBotAng*x
    translate -BaseBotRad1*y 
    }
      

#declare Base =
  object {
    difference {
      union {
        object { Base_Mid }
        object { Base_Top translate < BaseLen-BaseTopLen-BaseTopOff, 0.0, BaseDep-(BaseTopDep-BaseTopOff)> }
        object { Base_Bot }
        object { ibm_logo translate < 15.75, 0.0, 5.0> }
        }
      union {
        object { Base_Groove translate <BaseGrooveOffX, BaseHgt      , BaseGrooveOffZ> }
        object { Base_Hole_1 translate <BaseHole1OffX, -BaseHoleHgt/2, BaseHole1OffZ>}
        object { Base_Hole_2 translate <BaseHole2OffX, -BaseHoleHgt/2, BaseHole2OffZ>}
        object { Base_Hole_3 translate <BaseHole3OffX, -BaseHoleHgt/2, BaseHole3OffZ>}
        object { Base_Hole_4 translate <BaseHole4OffX, -BaseHoleHgt/2, BaseHole4OffZ>}
        object { Base_Hole_5 translate <BaseHole5OffX, -BaseHoleHgt/2, BaseHole5OffZ>}
        object { Base_Hole_6 translate <BaseHole6OffX, -BaseHoleHgt/2, BaseHole6OffZ>}
        object { Base_Hole_7 translate <BaseHole7OffX, -BaseHoleHgt/2, BaseHole7OffZ>}
        object { Base_Hole_8 translate <BaseHole8OffX, -BaseHoleHgt/2, BaseHole8OffZ>}
        object { Base_Hole_9 translate <BaseHole9OffX, -BaseHoleHgt/2, BaseHole9OffZ>}
        object { Base_Hole_10 translate <BaseHole10OffX, -BaseHoleHgt/2, BaseHole10OffZ>}
        }
      }
    }    

#declare fKeyboardDepth  = BaseDep*cos(radians(10))-1/16 ;
#declare fKeyboardHeight = BaseDep*sin(radians(10))+2*BaseRad;
#declare fKeyboardOffX   = 0.25;
#declare fKeyboardOffY   = 0.5;

#declare oIBMKeyboard =
  object {
    union {
      object {
        union {
          object {Base}
          object {Keys  translate <(BaseHole1Len-15*fKeyWidth)/2+BaseHole1OffX,0,(BaseHole1Dep-5*fKeyDepth)/2+BaseHole1OffZ>}
          object {Keys2 translate <(BaseHole2Len- 3*fKeyWidth)/2+BaseHole2OffX,0,(BaseHole2Dep-2*fKeyDepth)/2+BaseHole2OffZ>}
          object {Keys3 translate <(BaseHole3Len- 3*fKeyWidth)/2+BaseHole3OffX,0,(BaseHole3Dep-2*fKeyDepth)/2+BaseHole3OffZ>}
          object {Keys4 translate <(BaseHole4Len- 4*fKeyWidth)/2+BaseHole4OffX,0,(BaseHole4Dep-5*fKeyDepth)/2+BaseHole4OffZ>}
          object {Keys5 translate <(BaseHole5Len-   fKeyWidth)/2+BaseHole5OffX,0,(BaseHole5Dep-  fKeyDepth)/2+BaseHole5OffZ>}
          object {Keys6 translate <(BaseHole6Len- 4*fKeyWidth)/2+BaseHole6OffX,0,(BaseHole6Dep-  fKeyDepth)/2+BaseHole6OffZ>}
          object {Keys7 translate <(BaseHole7Len- 4*fKeyWidth)/2+BaseHole7OffX,0,(BaseHole7Dep-  fKeyDepth)/2+BaseHole7OffZ>}
          object {Keys8 translate <(BaseHole8Len- 4*fKeyWidth)/2+BaseHole8OffX,0,(BaseHole8Dep-  fKeyDepth)/2+BaseHole8OffZ>}
          object {Keys9 translate <(BaseHole9Len- 3*fKeyWidth)/2+BaseHole9OffX,0,(BaseHole9Dep-  fKeyDepth)/2+BaseHole9OffZ>}
          object {BaseLights translate <BaseHole10OffX,0,BaseHole10OffZ>}
          }
        rotate -10*x
        translate 0.5*y
        }
      object {
        union {
          object {Round_Box(<fKeyboardOffX,0,0><BaseLen-fKeyboardOffX,3*BaseRad,fKeyboardDepth>,BaseRad,false)}
          object {Round_Box(<fKeyboardOffX,0,0><BaseLen-fKeyboardOffX,fKeyboardOffY,3*BaseRad>,BaseRad,false)}
          object {Round_Box(<fKeyboardOffX,0,fKeyboardDepth-3*BaseRad><BaseLen-fKeyboardOffX,fKeyboardOffY+fKeyboardHeight,fKeyboardDepth>,BaseRad,false)}
          object {triangle{<fKeyboardOffX,fKeyboardOffY+fKeyboardHeight-BaseRad,fKeyboardDepth-BaseRad><fKeyboardOffX,fKeyboardOffY-BaseRad,BaseRad><fKeyboardOffX,BaseRad,fKeyboardDepth-BaseRad>}}
          object {triangle{<fKeyboardOffX,BaseRad,BaseRad><fKeyboardOffX,fKeyboardOffY-BaseRad,BaseRad><fKeyboardOffX,BaseRad,fKeyboardDepth-BaseRad>}}
          object {triangle{<BaseLen-fKeyboardOffX,fKeyboardOffY+fKeyboardHeight-BaseRad,fKeyboardDepth-BaseRad><BaseLen-fKeyboardOffX,fKeyboardOffY-BaseRad,BaseRad><BaseLen-fKeyboardOffX,BaseRad,fKeyboardDepth-BaseRad>}}
          object {triangle{<BaseLen-fKeyboardOffX,BaseRad,BaseRad><BaseLen-fKeyboardOffX,fKeyboardOffY-BaseRad,BaseRad><BaseLen-fKeyboardOffX,BaseRad,fKeyboardDepth-BaseRad>}}
          }
        }
      }
    scale 1/12
//    texture{pigment{White*0.05} 
//            normal { bumps 0.04 scale 0.0005 }
//            finish { phong 0.5 }
//            }

    }    

