// Persistence of Vision Ray Tracer Scene Description File
// File: IBMLogo.inc
// Vers: 3.6
// Desc: IBM Logo
// Date: 10/27/2004
// Auth: David E. LeMasters
//
 
 
#macro IBMLogo(fWidth,fHeight,fDepth)
  #local fIBMLogoX     = fWidth/29;
  #local fIBMLogoY     = fHeight/15;
  #local oIBMLogoI =
    object {
      prism {
        linear_spline  0,  fDepth,
        13,
        < 0, 0>,< 6, 0>,< 6, 3>,< 4, 3>,< 4, 12>, < 6, 12>, <6, 15>,
        < 0, 15>,< 0, 12>,< 2, 12>,< 2, 3>,< 0, 3>,< 0, 0>
        }
      rotate -90*x
      }
 
  #local oIBMLogoB =
    object {
      union {
        object {
          prism {
            linear_spline  0, fDepth,
            17,
            < 0, 0>,< 5.00, 0>,< 5.00, 3>,< 4, 3>,< 4, 6>,< 5.00, 6>,
            < 5.00, 9>,< 4, 9>,< 4,12>,< 5.00,12>,< 5.00,15>,< 0,15>,
            < 0,12>,< 2,12>,< 2, 3>,< 0, 3>,< 0, 0>
            }
          }
        object {
          intersection {
            union {
              difference {
                cylinder { < 5.00, 0.000, 4.00>< 5.00, fDepth             , 4.00 >,4.00}
                cylinder { < 5.00,-0.005, 4.50>< 5.00, fDepth+0.005, 4.50 >,1.50}
                }
              difference {
                cylinder { < 5.00, 0.000,11.00>< 5.00, fDepth             ,11.00 >,4.00}
                cylinder { < 5.00,-0.005,10.50>< 5.00, fDepth+0.005,10.50 >,1.50}
                }
              }
            box{<5.00,-0.01,0>< 9,fDepth+0.01,15>}
            }
          }
        }
      rotate -90*x
      }
 
  #local oIBMLogoM =
    object {
      prism {
        linear_spline  0, fDepth,
        21,
        < 0, 0>,< 4, 0>,< 4, 6>,< 6, 0>,< 8, 6>,< 8, 0>,<12, 0>,
        <12, 3>,<10, 3>,<10,12>,<12,12>,<12,15>,< 8,15>,< 6, 8>,
        < 4,15>,< 0,15>,< 0,12>,< 2,12>,< 2, 3>,< 0, 3>,< 0, 0>
        }
      rotate -90*x
      }
 
  #local oIBMLogo =
    object {
      difference {
        union {
          object { oIBMLogoI scale < fIBMLogoX, fIBMLogoY, 1.0> }
          object { oIBMLogoB scale < fIBMLogoX, fIBMLogoY, 1.0> translate fIBMLogoX* 7*x }
          object { oIBMLogoM scale < fIBMLogoX, fIBMLogoY, 1.0> translate fIBMLogoX*17*x }
          }
        union {
          #local iy = 1;
          #while (iy < 15)
            object {
              box{< 0, 0, 0.01><fWidth,fHeight/15, -(fDepth+0.01)>}
              translate iy*fHeight/15*y
              }
            #local iy = iy + 2;
          #end
          }
        }
      }
  oIBMLogo
#end
