#include "IBMLogo.inc"

#macro IBMPS2(vColor)
  #local fWidth = 14.00;
  #local fHeight = 4.5;
  #local fDepth = 15.5;
  #local fRadius = 0.125;
  #local tIBMPS2Texture = texture {
                          pigment{vColor}                   //* Base Texture                        */
                          normal { bumps 0.04 scale 0.0005 }
                          finish { phong .5 }
                          };
 
  #local fFloppyWidth = 6;
  #local fFloppyTopHeight = 1.250;
  #local fFloppyTopDepth = 0.375;
  #local fFloppyTopRadius = 0.0625;
  #local fFloppyHeight = 3.25;
  #local fFloppyXOffset = 5.25;
  #local fFloppyYOffset = 0.625;
  #local fFloppyWidth1  = 1.00;
  #local fFloppyWidth2  = 1.25;
  #local fFloppyWidth3  = 1.50;
  #local fFloppyWidth4  = 1.25;
  #local fFloppyWidth5  = 1.00;
  #local fFloppyHeight1 = 0.125;
  #local fFloppyHeight2 = 0.50;
  #local fFloppyHeight3 = 0.250;
  #local fFloppyHeight4 = 0.250;
  #local fFloppyHeight5 = 0.125;
  #local fFloppyXOffset1 = fFloppyWidth1;
  #local fFloppyXOffset2 = fFloppyXOffset1+fFloppyWidth2;
  #local fFloppyXOffset3 = fFloppyXOffset2+fFloppyWidth3;
  #local fFloppyXOffset4 = fFloppyXOffset3+fFloppyWidth4;
  #local fFloppyYOffset1 = fFloppyHeight1;
  #local fFloppyYOffset2 = fFloppyYOffset1+fFloppyHeight2;
  #local fFloppyYOffset3 = fFloppyYOffset2+fFloppyHeight3;
  #local fFloppyYOffset4 = fFloppyYOffset3+fFloppyHeight4;
  #local fFloppyBottomHeight = fFloppyHeight-fFloppyTopHeight+fFloppyTopRadius;
 
  #local fPowerWidth = 2.25;
  #local fPowerHeight = fFloppyHeight;
  #local fPowerRadius = 0.0625;
  #local fPowerXOffset = fFloppyXOffset+fFloppyWidth;
  #local fPowerYOffset = fFloppyYOffset;
  #local fPowerTopHeight = 1.25;
  #local fPowerTopDepth  = 0.375;
  #local fPowerTopRadius = 0.0625;
  #local fPowerSwitchWidth = 0.875;
  #local fPowerSwitchHeight =0.875;
  #local fPowerSwitchXOffset = 1.1875;
  #local fPowerSwitchZOffset = 0.125;
  #local fPowerSwitchBorder = 1/32;
  #local tPowerSwitchTexture = texture{pigment{vColor} finish{reflection 0.1 phong 0.3 phong_size 60}};
  #local fPowerLEDWidth = 0.1875;
  #local fPowerLEDHeight = 0.09375;
  #local fPowerLEDXOffset = 0.8125;
  #local fPowerLEDYOffset = 0.75;
  #local fPowerDiskLEDXOffset = 0.3125;
  #local fPowerLEDBorder = 1/64;
  #local tPowerLEDTexture = pigment{Green*0.95};
  #local tPowerDiskLEDTexture = pigment{Yellow*0.05};
  #local fPowerBottomHeight = fPowerHeight-fPowerTopHeight+fPowerRadius;
  #local fPowerSerialWidth = 1.125;
  #local fPowerSerialHeight = 0.250;
  #local fPowerSerialDepth = 0.125;
  #local fPowerSerialXOffset = 0.75;
  #local fPowerSerialYOffset = 1.50;
 
  #local fFloppyAngle = atan((fFloppyTopDepth-2*fFloppyTopRadius)/fFloppyHeight2);
  #local fFloppyAngleHeight = fFloppyHeight2/cos(fFloppyAngle);
  #local fFloppyLEDWidth = 0.1875;
  #local fFloppyLEDHeight = 0.09375;
  #local fFloppyLEDXOffset = 1.50;
  #local fFloppyLEDYOffset = 0.25;
  #local fFloppyLEDTexture = pigment{Green*0.05};
  #local fFloppyLEDBorder = 1/64;
  #local fFloppyButtonWidth = 0.5;
  #local fFloppyButtonHeight = 0.1875;
  #local fFloppyButtonDepth = 0.125;
  #local fFloppyButtonRadius = 1/32;
  #local fFloppyButtonXOffset = 4.00;
  #local fFloppyButtonYOffset = 0.25;
  #local fFloppyButtonTexture = pigment{Blue};
  #local fFloppyButtonBorder = 1/32;
  
  #local fLogoWidth = 1.5;
  #local fLogoDepth = 0.525;
  #local fLogoHeight = 1.00;
  #local fLogoXOffset = 0.625;
  #local fLogoYOffset = 3.500;
  #local fLogoZOffset = -0.0625;
 
  #local fIBMWidth         = fLogoWidth*0.55;
  #local fIBMHeight        = fIBMWidth*0.45;;
  #local fIBMDepth         = 1/16;
  #local fIBMAngle         = 30;
  #local fIBMXOffset       =  0.375;
  #local fIBMYOffset       =  0.2;
  #local fPS2XOffset       =  0.875;
  #local fPS2YOffset       =  0.1250;
  
  
 
  #local oPS2Text =    
    object {
      text { ttf "ariblk.ttf" "PS/2" 0.125, <0,0,0>}
      scale 0.25
      pigment{White}
      }
      
  #local oLogo =
    object {
      union {
        cylinder{<0,0,0><0,0,fLogoDepth>,fLogoHeight*0.5                translate <fLogoHeight*0.5,fLogoHeight*0.5,0>}
        box     {<0,0,0><fLogoWidth-fLogoHeight,fLogoHeight,fLogoDepth> translate <fLogoHeight*0.5, 0, 0>            }
        cylinder{<0,0,0><0,0,fLogoDepth>,fLogoHeight*0.5                translate <fLogoWidth-fLogoHeight*0.5,fLogoHeight*0.5,0>}
        object  { IBMLogo(fIBMWidth,fIBMHeight,fIBMDepth) rotate fIBMAngle*z translate <fIBMXOffset,fIBMYOffset,-fIBMDepth> pigment{White}}
        object  { oPS2Text rotate fIBMAngle*z translate <fPS2XOffset,fPS2YOffset,-fIBMDepth>}
        }
//      pigment{Black}
      }
      
  #local oSerial =
    object {
      box{<0,0,0><fPowerSerialWidth,fPowerSerialHeight,0.01>}
      pigment{White}
      }
 
  #local oFloppyLEDHole =
    object {
      box{<-fFloppyLEDBorder,-fFloppyLEDBorder,-0.1><fFloppyLEDWidth-fFloppyLEDBorder,fFloppyLEDHeight+fFloppyLEDBorder,fFloppyTopDepth>}
      }
  #local oFloppyLED =
    object {
      box{<0,0,0>,<fFloppyLEDWidth,fFloppyLEDHeight,fFloppyTopDepth>}
      texture{fFloppyLEDTexture}
      }
 
 
  #local oFloppyButtonHole =
    object {
      box{<-fFloppyButtonBorder,-fFloppyButtonBorder,-0.1><fFloppyButtonWidth-fFloppyButtonBorder,fFloppyButtonHeight+fFloppyButtonBorder,fFloppyTopDepth>}
      }
 
  #local oFloppyButton =
    object {
      Round_Box(<0,0,0>,<fFloppyButtonWidth,fFloppyButtonHeight,fFloppyTopDepth+fFloppyButtonDepth>,fFloppyButtonRadius,false)
      texture{fFloppyButtonTexture}
      }
 
  #local oFloppyTopPanel =
    object {
      union{
        object {
          union {
            difference {
              union {
                object {
                  Round_Box(<0,0,0>,<fFloppyWidth1,fFloppyTopHeight,fFloppyTopDepth>,fFloppyTopRadius,false)
                  }
                object {
                  Round_Box(<-2*fFloppyTopRadius,0,0>,<fFloppyWidth2,fFloppyHeight1+fFloppyHeight2,fFloppyTopDepth>,fFloppyTopRadius,false)
                  translate <fFloppyXOffset1,0,0>
                  }
                object {
                  Round_Box(<-2*fFloppyTopRadius,0,0>,<fFloppyWidth2,fFloppyHeight4+fFloppyHeight5,fFloppyTopDepth>,fFloppyTopRadius,false)
                  translate <fFloppyXOffset1,fFloppyYOffset3,0>
                  }
                object {
                  Round_Box(<-2*fFloppyTopRadius,0,0>,<fFloppyWidth3+2*fFloppyTopRadius,fFloppyHeight1,fFloppyTopDepth>,fFloppyTopRadius,false)
                  translate <fFloppyXOffset2,0,0>
                  }
                object {
                  Round_Box(<-2*fFloppyTopRadius,0,0>,<fFloppyWidth3+2*fFloppyTopRadius,fFloppyHeight5,fFloppyTopDepth>,fFloppyTopRadius,false)
                  translate <fFloppyXOffset2,fFloppyYOffset4,0>
                  }
                object {
                  Round_Box(<0,0,0>,<fFloppyWidth4+2*fFloppyTopRadius,fFloppyHeight1+fFloppyHeight2,fFloppyTopDepth>,fFloppyTopRadius,false)
                  translate <fFloppyXOffset3,0,0>
                  }
                object {
                  Round_Box(<0,0,0>,<fFloppyWidth4+2*fFloppyTopRadius,fFloppyHeight4+fFloppyHeight5,fFloppyTopDepth>,fFloppyTopRadius,false)
                  translate <fFloppyXOffset3,fFloppyYOffset3,0>
                  }
                object {
                  Round_Box(<0,0,0>,<fFloppyWidth5,fFloppyTopHeight,fFloppyTopDepth>,fFloppyTopRadius,false)
                  translate <fFloppyXOffset4,0,0>
                  }
                object {
                  box{<-fFloppyTopRadius,0,-fFloppyTopRadius><fFloppyWidth3+fFloppyTopRadius,fFloppyAngleHeight,fFloppyTopRadius>}
                  rotate degrees(fFloppyAngle)*x
                  translate <fFloppyXOffset2,fFloppyYOffset1-fFloppyTopRadius,fFloppyTopRadius>
                  }
                }
              object {
                oFloppyLEDHole
                translate <fFloppyLEDXOffset,fFloppyLEDYOffset,0>
                }
              object {
                oFloppyButtonHole
                translate <fFloppyButtonXOffset,fFloppyButtonYOffset,0>
                }
              }
            object {
              oFloppyLED
              translate <fFloppyLEDXOffset,fFloppyLEDYOffset,0>
              }
            }
          Shear_Trans(x,y+(fFloppyTopDepth/fFloppyTopHeight)*z,z)
          }
        object {
          oFloppyButton
          translate <fFloppyButtonXOffset,fFloppyButtonYOffset,0>
          }
        }
      translate -fFloppyTopDepth*z
      }
 
  #local oFloppyBottomPanel =
    object {
      difference {
        object {
          Round_Box(<0,0,0>,<fFloppyWidth,fFloppyBottomHeight,fFloppyTopDepth>,fFloppyTopRadius,false)
          }
        }
      }
 
  #local oFloppyPanel =
    object {
      union {
        object {oFloppyTopPanel translate (fFloppyBottomHeight-fFloppyTopRadius)*y}
        object {oFloppyBottomPanel}
        }
      }
 
  #local oPowerLEDHole =
    object {
      box{<-fPowerLEDBorder,-fPowerLEDBorder,-0.1><fPowerLEDWidth+fPowerLEDBorder,fPowerLEDHeight+fPowerLEDBorder,fPowerTopDepth+0.1>}
      }
 
  #local oPowerLED =
    object {
      box{<0,0,0><fPowerLEDWidth,fPowerLEDHeight,fPowerTopDepth>}
      }
 
  #local oPowerSwitch =
    object {
      difference {
        object{
          Round_Box(<fPowerSwitchBorder,fPowerSwitchBorder,0>,
                    <fPowerSwitchWidth-fPowerSwitchBorder,fPowerSwitchHeight-fPowerSwitchBorder,fPowerTopDepth>,
                    fPowerTopRadius,false)
          }
        sphere{<fPowerSwitchWidth/2,fPowerSwitchHeight/2,-0.96>,-1}
        }
      }
 
  #local oPowerTopPanel =
    object {
      union {
        difference {
          union {
            object {
              Round_Box(<0,0,0>,<fPowerSwitchXOffset,fPowerTopHeight,fPowerTopDepth>,fPowerTopRadius,false)
              }
            object {
              Round_Box(<fPowerSwitchXOffset-2*fPowerTopRadius,fPowerSwitchHeight,0>,
                        <fPowerSwitchXOffset+fPowerSwitchWidth+2*fPowerTopRadius,fPowerTopHeight,fPowerTopDepth>,
                        fPowerTopRadius,
                        false
                        )
              }
            object {
              Round_Box(<fPowerSwitchXOffset+fPowerSwitchWidth,0,0>,<fPowerWidth,fPowerTopHeight,fPowerTopDepth>,fPowerTopRadius,false)
              }
            }
          object {
            oPowerLEDHole
            translate <fPowerDiskLEDXOffset,fPowerLEDYOffset,0>
            }
          object {
            oPowerLEDHole
            translate <fPowerLEDXOffset,fPowerLEDYOffset,0>
            }
          }
        object {
          oPowerLED
          translate <fPowerDiskLEDXOffset,fPowerLEDYOffset,0>
          texture{tPowerDiskLEDTexture}
          }
        object {
          oPowerLED
          translate <fPowerLEDXOffset,fPowerLEDYOffset,0>
          texture{tPowerLEDTexture}
          }
        object {
          oPowerSwitch
          translate <fPowerSwitchXOffset,0,fPowerSwitchZOffset>
          texture {tPowerSwitchTexture}
          }
        }
      Shear_Trans(x,y+(fPowerTopDepth/fPowerTopHeight)*z,z)
      translate -fPowerTopDepth*z
      }
 
  #local oPowerBottomPanel =
    object {
      union {
        difference {
          object {
            Round_Box(<0,0,0>,<fPowerWidth,fPowerBottomHeight,fPowerSerialDepth>,fPowerRadius,false)
            }
          object {
            box{<0,0,-0.1><fPowerSerialWidth,fPowerSerialHeight,fPowerSerialDepth+0.1>}
            translate <fPowerSerialXOffset,fPowerSerialYOffset,0>
            }
          }
        object {
          oSerial
          translate <fPowerSerialXOffset,fPowerSerialYOffset,fPowerSerialDepth>
          }
        }
      }
 
  #local oPowerPanel =
    object {
      union {
        object {oPowerTopPanel translate (fPowerBottomHeight-fPowerRadius)*y}
        object {oPowerBottomPanel}
        }
      }
 
  #local oCase =
    object {
      difference {
        object {
          Round_Box(<0,0,0>,<fWidth,fHeight,fDepth>,fRadius,false)
          }
        object {
          Round_Box(<0,0,-0.1>,<fFloppyWidth+fPowerWidth,fFloppyHeight,fFloppyTopDepth+0.1>,fFloppyTopRadius,false)
          translate <fFloppyXOffset,fFloppyYOffset,0>
          }
        }
      }
 
  #local oIBMPS2 =
    object {
      union {
        object {oCase}
        object {
          union {
            object {oFloppyPanel}
            object {oPowerPanel translate fFloppyWidth*x}
            }
          translate <fFloppyXOffset,fFloppyYOffset,0>
          }
        object {oLogo scale 0.50 translate <fLogoXOffset, fLogoYOffset,fLogoZOffset>}
        }
      texture{tIBMPS2Texture}
      scale 1/12
      }
  oIBMPS2
#end
