#macro Mouse()
  #local fWidthRadius  = 1.5;
  #local fRadius = 2;
  #local fXOffset = 0.75*fRadius;
  #local fYOffset = sqrt(f_sqr(fRadius)-f_sqr(fXOffset));
  #local fAngle   = degrees(asin(fXOffset/fRadius));
  #local tTexture = texture{pigment{White*0.05} 
                    normal { bumps 0.04 scale 0.0005 }
                    finish { phong 0.5 }
                    }
  
  #local oNotch1 =
    object {
      difference {
        cylinder{<0,-(fWidthRadius+0.1),0><0,(fWidthRadius+0.1),0>,fRadius*0.9}
        cylinder{<0,-(fWidthRadius+0.2),0><0,(fWidthRadius+0.2),0>,fRadius*0.9-0.125}
        }
      }
  
  #local oMouseHalf =
    object {
      union {
        object {
          intersection {
              union {
                cylinder{<0,-fWidthRadius,0><0, fWidthRadius, 0>,fRadius}
                torus{fRadius,fWidthRadius}
                }
            object{Wedge(90+fAngle) rotate -fAngle*y}
            }  
          rotate -90*x
          }
        object {
          union {
            sphere{<-fXOffset,fYOffset,0>,fWidthRadius}
            cylinder{<-fXOffset,0,0><-fXOffset,fYOffset,0>,fWidthRadius}
            box{<-fXOffset,0,-fWidthRadius><0,fYOffset,fWidthRadius>}
            }
          }  
        }  
      scale <1,0.5,1>
      }
      
  #local oMouseBack =
    object {
      oMouseHalf
      clipped_by{plane{-x,0}}
      }
      
  #local oMouseFront =
    object {
      oMouseHalf
      clipped_by{plane{ x,0}}
      scale <1.5,1,1>
      }
      
  #local oMouse =
    object {
      union {
        object {oMouseBack}
        object {oMouseFront}
        }
      texture{tTexture}
      scale 1/18
      }
      
  oMouse
#end