#macro PCMonitor(sImage) 
  #local fWidth  = 16.00;
  #local fHeight = 12.00;
  #local fDepth  =  3.00;
  #local fRadius =  0.125; 
  
  #local fScreenWidth  = 13.00;
  #local fScreenHeight =  9.50;
  #local fScreenDepth  =  0.25;
  #local fScreenXOffset = (fWidth-fScreenWidth)/2;
  #local fScreenYOffset = (fHeight-fScreenHeight)/2;
  
  #local fCaseRadius    = fHeight;
  #local fCaseWidth     = 8.00;
  #local fCaseHeight    = 6.00;
  #local fCaseDepth     = 8.00;
  #local fCaseXOffset   = (fWidth-fCaseWidth)/2;
  #local fCaseYOffset   = (fHeight-fCaseHeight)/2;
  #local fCaseZOffset   = 6.00;
                                
  #local fBaseRadius    =  8.00;
  #local fBaseHeight    =  2.00;
                                  
  #local oMonitorFace =
    object {
      union {
        difference{
          object {
            Round_Box(<0,0,0>,<fWidth,fHeight,fDepth>,fRadius,false)
            }
          box{
            <-fRadius,-fRadius,-0.1><fScreenWidth+fRadius,fScreenHeight+fRadius,fScreenDepth> 
            translate <fScreenXOffset,fScreenYOffset,0>
            }
          }
        box{
          <-fRadius,-fRadius, fScreenDepth><fScreenWidth+fRadius,fScreenHeight+fRadius,fScreenDepth-0.0001> 
          translate <fScreenXOffset,fScreenYOffset,0>
          pigment{Gray50}
          }                
        object {  
          box{<0,0,0><1,1,1>}  
          pigment{image_map{jpeg concat("Keyboard/",sImage)}}
          scale <fScreenWidth,fScreenHeight,0.001>
          translate <fScreenXOffset,fScreenYOffset,fScreenDepth-0.0002>
          }
        }
      }
      
  #local oMonitorCase =
    object { 
      union {
        intersection {
          cylinder{<0,0,0><0,fHeight,0>,fCaseRadius translate (fWidth-fCaseRadius)*x} 
          cylinder{<0,0,0><0,fHeight,0>,fCaseRadius translate (fCaseRadius)*x }
          cylinder{<0,0,0><fWidth,0,0>,fCaseRadius translate fCaseRadius*y}
          cylinder{<0,0,0><fWidth,0,0>,fCaseRadius translate (fHeight-fCaseRadius)*y}
          }
        box {<0,0,0><fCaseWidth,fCaseHeight,fCaseDepth> translate <fCaseXOffset,fCaseYOffset,fCaseZOffset>}  
        }
      clipped_by{plane {-z,0}}                                                             
      }
       
  #local oMonitorBase =
    object {
      union {
        object {
          sphere{<0,0,0>,fBaseRadius translate <fWidth/2,-fBaseRadius,6.00> clipped_by{plane{-y,fBaseHeight}}}
          }
        }
      }
             
  #local oMonitor =
    object {
      union {
        object { oMonitorFace } 
        object { oMonitorCase translate fDepth*z}
        object {oMonitorBase  }
        }
      translate fBaseHeight*y
      scale 1/12
      }
      
  oMonitor
            
#end