#macro Moulding(fDepth)
  #local fWidth = 0.75;
  #local fHeight = 0.75;
  #local fRadius1 = 0.5000;
  #local fRadius2 = 0.0625;
  #local fRadius3 = 0.0625;
  
  #local oMoulding =
    object {
      intersection {
        union {
          box{<0,0,0><fRadius2+fRadius1,fHeight-(fRadius1+fRadius3),fDepth>}
          box{<0,fHeight-(fRadius1+fRadius3),0><fWidth,fHeight-fRadius1,fDepth>}
          box{<0,fHeight-fRadius1,0><fRadius2,fHeight-fRadius2,fDepth>}
          intersection {
            cylinder{<fRadius2,fHeight-fRadius1,0><fRadius2,fHeight-fRadius1,fDepth>,fRadius1}
            box{<fRadius2,fHeight-fRadius1,0-0.1><fRadius2+fRadius1,fHeight,fDepth+0.1>}
            }
          cylinder{<fRadius2,fHeight-fRadius2,0><fRadius2,fHeight-fRadius2,fDepth>,fRadius2}
          cylinder{<fWidth-fRadius3,fHeight-fRadius1,0><fWidth-fRadius3,fHeight-fRadius1,fDepth>,fRadius3}
          }
        box{<0,-0.1,0><fDepth/sqrt(2),fHeight+0.1,fDepth/sqrt(2)> rotate -45*y}
        }
      texture{T_Wood1 finish { phong 2.5 }}
      }
      
  oMoulding
#end

#macro Frame(fWidth,fDepth)
  #local oFrame =
    object {
      union {
        object {Moulding(fDepth)}
        object {Moulding(fDepth) rotate 180*y translate <fWidth,0,fDepth>}
        object {Moulding(fWidth) rotate  90*y translate fDepth*z}
        object {Moulding(fWidth) rotate -90*y translate fWidth*x}
//        box{<0.5,0.125,0.5><7.5,0.1875,5.5> texture {T_Glass1}}
        box{<0,0,0><1,1,1> pigment{image_map{jpeg "baseban"}} rotate 90*x scale <7,0.0625,5> translate <0.5,0.125,0.5>}
        }
      scale 1/12
      }
  oFrame
#end
