#macro SmokeDetector()
  #local fBaseRadius = 3.0;
  #local fBaseHeight = 0.25;
  #local fBaseEdgeRadius = 0.0625;
  #local fMidRadius  = 1.75;
  #local fMidHeight = 1.00;
  #local fMidEdgeRadius = 0.0625;
  #local fBottomGap  = 0.25;
  #local fBottomRadius = 0.75;
  #local fBottomHeight = 0.25;
  #local fBottomEdgeRadius = 0.0625;
  #local fSupportWidth = 0.125;
  #local fSupportHeight = 0.375;
  #local fSupportDepth = 0.25;
  #local tTexture = pigment{rgb <0.85,0.85,0.65>};
  
  #local oBase =
    object {
      Round_Cylinder(<0, fBaseEdgeRadius,0>,<0,-fBaseHeight, 0>,fBaseRadius,fBaseEdgeRadius,false)
      }
  
  #local oMiddle =
    object {
      Round_Cylinder(<0, fMidEdgeRadius,0>,<0,-fMidHeight, 0>,fMidRadius,fMidEdgeRadius,false)
      }
  
  #local oSupport =
    object {
      union {
        #local i = 0;
        #while(i < 6)
          box{<0,0,0><fSupportWidth,-fSupportHeight,fSupportDepth> translate -fBottomRadius*z rotate i*60*y}
          #local i = i + 1;
        #end
        }
      }
          
  #local oBottom =
    object {
      Round_Cylinder(<0, fBottomEdgeRadius,0>,<0,-fBottomHeight, 0>,fBottomRadius,fBottomEdgeRadius,false)
      }
      
  #local oSmokeDetector =
    object {
      union {
        object {oBase}
        object {oMiddle translate -fBaseHeight*y}
        object {oSupport translate -(fBaseHeight+fMidHeight)*y}
        object {oBottom translate -(fBaseHeight+fMidHeight+fSupportHeight)*y}
        }
      texture {tTexture}
      scale 1/12  
      }                 
  
  oSmokeDetector    
#end