#macro Sprinkler()
  #local fBaseEdge   = 0.0625;
  #local fBaseRadius = 1.0;
  #local fBaseHeight = -0.25;
  #local fPostRadius = 0.125;
  #local fPostHeight = -2.5;       
  #local fValveRadius = 0.250;
  #local fValveHeight = 1.0;
  #local fRibRadius  = 0.5;
  #local fRibWidth   = 0.25;
  #local fRibHeight  = -1.0;
  #local fRibDepth   = 0.125;
  #local tTexture    = T_Chrome_2B;
  
  #local oBase =
    object {
      Round_Cylinder(<0,0,0>,<0,fBaseHeight,0>,fBaseRadius,fBaseEdge,false)
      }
      
  #declare oPost =
    object {
      cylinder{<0,0,0><0,fPostHeight,0>,fPostRadius}
      }
      
  #declare oValve =
    object {
      cylinder{<0,0,0><0,fValveHeight,0>,fValveRadius}
      }
      
  #local oElbow =
    object {
      intersection {
        difference {
          cylinder{<0,0,0><0,fRibDepth,0>,fRibRadius}
          cylinder{<0,-0.1,0><0,fRibDepth+0.1,0>,fRibRadius-fRibWidth}
          }
        object {Wedge(90)}
        }
      rotate -90*x
      } 
      
  #local oRib =
    object {
      union {
        object {oElbow}
        object {box{<fRibRadius-fRibWidth,0,0><fRibRadius,fRibHeight,-fRibDepth>}}
        object {oElbow rotate -90*z translate fRibHeight*y}
        }
      translate <fPostRadius,-fRibRadius,fRibDepth/2>
      }
      
  #local oStrip =
    object {
      box{<0,0,0><fBaseRadius,fBaseHeight/4,fBaseRadius/8> translate <-fBaseRadius/2,0,-fBaseRadius/16>}
      }
      
  #local oHead =
    object {
      union {
        #local i = 0;
        #while (i < 6)
          object { oStrip rotate i*180/6*y }
          #local i = i + 1;
        #end
        }
      }
      
  #local oSprinkler =
    object {
      union {
        object { oBase }
        object { oPost }
        object { oRib  translate <0,fBaseHeight,0>}
        object { oRib  translate <0,fBaseHeight,0> rotate 180*y}
        object { oValve translate <0,-(fValveHeight-fRibHeight),0>} 
        object { oHead translate <0,fPostHeight,0>}
        }
      texture {tTexture}
      translate fBaseEdge*y 
      scale 1/12
      }
      
  oSprinkler
#end