#macro SwitchPlate()
  #local fWidth = 4.50;
  #local fHeight = 4.50;
  #local fDepth  =  1.00;
  #local fRadius = 0.25;
  
  #local fHoleHeight = 1.00;
  #local fHoleWidth = 0.375;
  
  #local fHoleXOffset =1.1875;
  #local fHoleYOffset = (fHeight-fHoleHeight)/2;       
  #local fScrewRadius = 0.125;     
  #local fScrewDepth  = 0.125;
  #local fScrewXOffset = fHoleXOffset+fHoleWidth/2;
  #local fScrewYOffset = 1.125;
  #local fScrewHeadRadius = 0.500;
  #local fScrewHeadZOffset = sqrt(f_sqr(fScrewHeadRadius)-f_sqr(fScrewRadius)); 
  #local fScrewSlotHeight  = fScrewRadius/6;
  #local fCaseWidth = fHoleWidth-1/32;
  #local fCaseHeight = fHoleHeight-1/32;
  #local fCaseDepth  = fDepth+0.1; 
  #local fCaseXOffset = 1/64;
  #local fCaseYOffset = 1/64;
  #local fCaseZOffset = -0.0625;
  #local fSwitchWidth = 0.250;
  #local fSwitchHeight = 0.75;    
  #local fSwitchHoleWidth = fSwitchWidth+1/32;
  #local fSwitchHoleHeight = fSwitchHeight+1/32;  
  
  #local fSwitchRadius = 0.5;
  #local fSwitchZOffset = 0.375;
  
  #local tPlateTexture = T_Chrome_1A;
  #local tSwitchTexture = pigment{DarkBrown}
  
  #local oSwitchCase =
    object {
      difference {
        box{<0,0,0><fCaseWidth,fCaseHeight,fCaseDepth>}
        box{<0,0,-0.1><fSwitchHoleWidth,fSwitchHoleHeight,fCaseDepth+0.1> translate <(fCaseWidth-fSwitchHoleWidth)/2,(fCaseHeight-fSwitchHoleHeight)/2,0> }
        } 
      }  
      
  #local oSwitchToggle =
    object {   
      union {   
        box{<0,0,0><fSwitchWidth, 0.5625,1> rotate  22.5*x}
        box{<0,0,0><fSwitchWidth,-0.5625,1> rotate -22.5*x}
        box{<0,-0.125,0.25><fSwitchWidth,0.125,-0.5>}
//        cylinder{<0,0,0><0,fSwitchWidth,0>,fSwitchRadius
        }
      translate -0.5*z
      rotate 22.5*x
      translate  0.5*z
//      pigment{Green}  
      }         
      
  #local oSwitch =
    object {
      union {
        object {oSwitchCase}
        object {oSwitchToggle translate <(fCaseWidth-fSwitchWidth)/2,(fCaseHeight)/2,0>}
        }
      texture {tSwitchTexture}  
      }    
  
  #local oScrewHole =
    object {
      cylinder{<0,0,-0.1><0,0,fDepth+0.1>,fScrewRadius}
      } 
      
  #local oScrew =
    object {
      difference {
        intersection {
          union {
            cone{<0,0,fScrewDepth>,fScrewRadius/2,<0,0,0>,fScrewRadius}
            cylinder{<0,0,0><0,0,-0.1>,fScrewRadius}
            }                                                          
          sphere{<0,0,fScrewHeadZOffset>,fScrewHeadRadius}
          }
        box {<-fScrewRadius-0.1,-fScrewSlotHeight,0><fScrewRadius+0.1,fScrewSlotHeight,-0.2>}  
        }
      }    
  
  #local oPlate =
    object {
      union {
        difference {
          object { Round_Box(<0,0,0>,<fWidth,fHeight,fDepth>,fRadius,false) }
          object { box{<0,0,-0.1><fHoleWidth,fHoleHeight,fDepth+0.1> translate <fHoleXOffset,fHoleYOffset,0>} }
          object { box{<0,0,-0.1><fHoleWidth,fHoleHeight,fDepth+0.1> translate <fWidth-fHoleWidth-fHoleXOffset,fHoleYOffset,0>} }
          object { oScrewHole translate <fScrewXOffset,fScrewYOffset,-0.020>}
          object { oScrewHole translate <fWidth-fScrewXOffset,fScrewYOffset,-0.020>}
          object { oScrewHole translate <fScrewXOffset,fHeight-fScrewYOffset,-0.020>}
          object { oScrewHole translate <fWidth-fScrewXOffset,fHeight-fScrewYOffset,-0.020>}
          }
        object {oScrew rotate 37*z translate <fScrewXOffset,fScrewYOffset,-0.010>}
        object {oScrew rotate 99*z translate <fWidth-fScrewXOffset,fScrewYOffset,-0.010>}
        object {oScrew rotate 92*z translate <fScrewXOffset,fHeight-fScrewYOffset,-0.010>}
        object {oScrew rotate 13*z translate <fWidth-fScrewXOffset,fHeight-fScrewYOffset,-0.010>} 
        object {oSwitch translate <fHoleXOffset+fCaseXOffset,fHoleYOffset+fCaseYOffset,fCaseZOffset>}
        object {oSwitch translate <fWidth-fHoleWidth-fHoleXOffset+fCaseXOffset,fHoleYOffset+fCaseYOffset,fCaseZOffset>}
        } 
      translate -fRadius/2*z   
      texture {tPlateTexture}
      scale 1/12
      }
      
  oPlate
#end
