#macro RedSwitchHole(fSize)
  #local fSwitchWidth   =  1.000;
  #local fSwitchHeight  =  1.750;
  #local fSwitchDepth   =  0.675;
  #local fSwitchRadius  =  0.0625;
  
  #local oHole =
    object {
      Round_Box(<-fSize,-fSize,-fSize>,<fSwitchWidth+fSize,fSwitchHeight+fSize,fSwitchDepth+fSize>,fSwitchRadius,false)
      }
      
  oHole
#end
  
#macro RedSwitch()
  #local fSwitchWidth   =  1.000;
  #local fSwitchHeight  =  1.750;
  #local fSwitchDepth   =  0.675;
  #local fSwitchRadius  =  0.0625;
  #local fSwitchBorder  =  0.0625;
  #local fSwitchGap     =  fSwitchHeight-2*(fSwitchBorder+fSwitchDepth);  //* Hole Height in the Middle
  #local fToggleRadius  =  fSwitchGap;
  #local fToggleWidth   =  fSwitchWidth-3*fSwitchBorder;
  #local fToggleHeight  =  0.125;
  #local fToggleDepth   =  fSwitchDepth+fToggleRadius;
  #local fToggleZOffset =  fToggleDepth;
  #local fToggleAngle   = 20;
  #local tSwitchTexture =  texture{pigment{Red} finish{reflection 0.1 phong 0.3 phong_size 60}};
  
  #local oSwitchBody =      
    object {
      difference {
        object {
          Round_Box(<0,0,-fSwitchRadius>,<fSwitchWidth,fSwitchHeight,fSwitchDepth>,fSwitchRadius,false)
          clipped_by{plane{-z, 0}}
          }
        object {
          Round_Box(<fSwitchBorder,0,0>,<fSwitchWidth-fSwitchBorder,fSwitchHeight,fSwitchHeight>,fSwitchRadius,false)
          translate <0,-fSwitchHeight/2,-fSwitchHeight/2>
          rotate 45*x
          translate <0,fSwitchHeight/2,(-fSwitchHeight/sqrt(2)+(fSwitchDepth+fSwitchGap/2))>
          }
        }
      }

  #local oSwitchToggle =
    object {
      union {
        object {Round_Cylinder(<0,0,0>,<fToggleWidth,0,0>,fToggleRadius,fSwitchRadius,false)}
        object{Round_Box(<0,-fToggleHeight/2,0>,<fToggleWidth,fToggleHeight/2,-fToggleDepth>,fSwitchRadius,false)}
        }
      rotate fToggleAngle*x
      }
      
  #local oSwitch =
    object {
      union {
        object{oSwitchBody}
        object{oSwitchToggle translate <(fSwitchWidth-fToggleWidth)/2,fSwitchHeight/2,fToggleZOffset>}
        }
      texture{tSwitchTexture}
      }
      
  oSwitch
#end