//***************************************************************************************************************/
//* Persistence of Vision Ray Tracer Scene Description File                                                     */
//* File: Vent.inc                                                                                              */
//* Vers: 3.6                                                                                                   */
//* Desc: Creat Vent Macro                                                                                      */
//* Date: 11/24/2004                                                                                            */
//* Auth: D. E. LeMasters                                                                                       */
//***************************************************************************************************************/
                                                                        //*                                     */
//***************************************************************************************************************/
//* Vent Macro Definition                                                                                       */
//***************************************************************************************************************/
#macro Vent(fWidth,fHeight,fThickness,iSlats)
  //*************************************************************************************************************/
  //* Vent Slat                                                                                                 */
  //*************************************************************************************************************/
  #local fSlatHeight = fHeight/iSlats;
  #local fAngle      = 45;
  #local oVentSlat =
    object {
      union {
        box{<0,0,-fThickness/2>< fWidth, fSlatHeight/3,fThickness/2>}
        cylinder{<0,fSlatHeight/3,0><fWidth,fSlatHeight/3,0>,fThickness/2}
        box{<0,0,-fThickness/2>< fWidth,fSlatHeight*2/3,fThickness/2> rotate fAngle*x translate fSlatHeight/3*y}
        }
      translate fThickness/2*z
      }
  //*************************************************************************************************************/
  //* Define Front Panel Vent                                                                                   */
  //*************************************************************************************************************/
  #local oVent =
    object {
      union {
        #local n = 0;
        #while ( n < iSlats)
          object {oVentSlat translate n*fSlatHeight*y}
          #local n = n + 1;
        #end
        }
      }
  //*************************************************************************************************************/
  oVent
#end                                                                    //*                                     */
//***************************************************************************************************************/
