#include "ExitSign.inc"
#include "Clock.inc"
#include "ClockSign.inc"
#include "FireAlarm.inc"
#include "FirePull.inc" 
#include "Doors.inc"       
#include "FireExt.inc"
#include "SwitchPlate.inc" 
#include "NetworkDiagram.inc"

#macro Walls()
  #local oDoorOpening =
    object {
      box{<0,0,-0.1><73/12,80/12,fWallThickness+0.1>}
      }
      
  #local oWalls =
    object {
      union {
        box{<-fWallThickness, 0,-fWallThickness>< fCenterWidth+fWallThickness, fCenterHeight, 0>}  //* South Wall
        box{<-fWallThickness, 0,-fWallThickness>< fCenterWidth+fWallThickness, fCenterHeight, 0> translate (fCenterDepth+fWallThickness)*z}    //* North Wall
        union {
          difference {
            box{<-fWallThickness, 0,-fWallThickness>< 0, fCenterHeight, fCenterDepth+fWallThickness>}  //* East Wall
            object {oDoorOpening rotate -90*y translate fDoorZOffset*z}
            }
          object {Doors() rotate -90*y translate fDoorZOffset*z}
          }   
        box{<-fWallThickness, 0,-fWallThickness>< 0, fCenterHeight, fCenterDepth+fWallThickness> translate (fCenterWidth+fWallThickness)*x}    //* West Wall
        object {ExitSign()       rotate -90*y translate <0,fCenterHeight-1.5, fDoorZOffset+2.5>}
        object {FireAlarm()      rotate  90*y translate <0, fCenterHeight-1.5, fDoorZOffset+7.5>}
        object {FirePull()       rotate -90*y translate <1/12, 4.0, fDoorZOffset+7.5>} 
        object {FireExt()        rotate -90*y translate <0.25, 1.0, fDoorZOffset+7.5>}
        object {SwitchPlate()    rotate -90*y translate <0.0, 3.5, fDoorZOffset+6.5>}
        object {NetworkDiagram() rotate -90*y translate <0.035, 4.5, fDoorZOffset-3.0>}
        object {Clock(11,57,12) translate <fCenterWidth/2-4,fCenterHeight-1.5,fCenterDepth>}
        object {Clock(12,57,12) translate <fCenterWidth/2-2,fCenterHeight-1.5,fCenterDepth>}
        object {Clock( 1,57,12) translate <fCenterWidth/2  ,fCenterHeight-1.5,fCenterDepth>}
        object {Clock( 2,57,12) translate <fCenterWidth/2+2,fCenterHeight-1.5,fCenterDepth>}
        object {Clock( 7,57,12) translate <fCenterWidth/2+4,fCenterHeight-1.5,fCenterDepth>}
        object {ClockSign("Los Angeles")   translate <fCenterWidth/2-4,fCenterHeight-3,fCenterDepth>}
        object {ClockSign("El Paso")       translate <fCenterWidth/2-2,fCenterHeight-3,fCenterDepth>}
        object {ClockSign("Indianapolis ") translate <fCenterWidth/2  ,fCenterHeight-3,fCenterDepth>}
        object {ClockSign("Boston")        translate <fCenterWidth/2+2,fCenterHeight-3,fCenterDepth>}
        object {ClockSign("Paris")         translate <fCenterWidth/2+4,fCenterHeight-3,fCenterDepth>}
        }
      texture { vCenterTexture }
      }
  oWalls
#end    
    
