#macro WasteBasket()
  #local fWidth       = 10;
  #local fHeight      = 12.00;
  #local fDepth       =  6;
  #local fThickness   = 0.125;
  #local fRadius      =  1;
  #local fEdgeRadius  = 0.125;
  #local fLipDepth    = 0.5;
  #local fLipHeight   = 0.5;  
  
  #local tBasketTexture = texture {pigment{ForestGreen} finish { phong 0.5 }};
  
  #local oBaseBasket =
    object {    
      union {
        object {Round_Cylinder(<fRadius,0,fRadius>,<fRadius,fHeight,fRadius>,fRadius,fEdgeRadius,false)}
        object {Round_Cylinder(<fWidth-fRadius,0,fRadius>,<fWidth-fRadius,fHeight,fRadius>,fRadius,fEdgeRadius,false)}
        object {Round_Cylinder(<fRadius,0,fDepth-fRadius>,<fRadius,fHeight,fDepth-fRadius>,fRadius,fEdgeRadius,false)}
        object {Round_Cylinder(<fWidth-fRadius,0,fDepth-fRadius>,<fWidth-fRadius,fHeight,fDepth-fRadius>,fRadius,fEdgeRadius,false)}
        object {Round_Box(<0,0,fRadius-fEdgeRadius>,<fWidth,fHeight,fDepth-fRadius+fEdgeRadius>,fEdgeRadius,false)} 
        object {Round_Box(<fRadius-fEdgeRadius,0,0>,<fWidth-fRadius+fEdgeRadius,fHeight,fDepth>,fEdgeRadius,false)}
        object {Round_Cylinder(<fRadius,fHeight-fLipHeight,fRadius>,<fRadius,fHeight,fRadius>,fRadius+fLipDepth,fEdgeRadius,false)}
        object {Round_Cylinder(<fWidth-fRadius,fHeight-fLipHeight,fRadius>,<fWidth-fRadius,fHeight,fRadius>,fRadius+fLipDepth,fEdgeRadius,false)}
        object {Round_Cylinder(<fRadius,fHeight-fLipHeight,fDepth-fRadius>,<fRadius,fHeight,fDepth-fRadius>,fRadius+fLipDepth,fEdgeRadius,false)}
        object {Round_Cylinder(<fWidth-fRadius,fHeight-fLipHeight,fDepth-fRadius>,<fWidth-fRadius,fHeight,fDepth-fRadius>,fRadius+fLipDepth,fEdgeRadius,false)}
        object {Round_Box(<-fLipDepth,fHeight-fLipHeight,fRadius-fEdgeRadius><fWidth+fLipDepth,fHeight,fDepth-fRadius+fEdgeRadius>,fEdgeRadius,false)}
        object {Round_Box(<fRadius-fEdgeRadius,fHeight-fLipHeight,-fLipDepth>,<fWidth-fRadius+fEdgeRadius,fHeight,fDepth+fLipDepth>,fEdgeRadius,false)}
        }
      }       
      
  #local oSquareBasket =
    object {
      difference {
        object {oBaseBasket}
        object {oBaseBasket scale <(fWidth-2*fThickness)/fWidth,1,(fDepth-2*fThickness)/fDepth> translate <fThickness,fLipHeight,fThickness>}    
        }       
      }
    
    
  #local oLeftBasket =
    object {
      oSquareBasket
      clipped_by{plane{ x, fWidth-fRadius}}                  
      Shear_Trans(x,y-x*0.05,z)
      }
    
  #local oRightBasket =
    object {
      oSquareBasket
      clipped_by{plane{ -x, -fRadius}}                  
      Shear_Trans(x,y+x*0.05,z)
      }
    
    
  #local oTaperBasket =
    object {
      union {
        object {oLeftBasket}
        object {oRightBasket}
        }  
      }
      
  #local oFrontBasket =
    object {
      oTaperBasket
      clipped_by{plane{ z,fDepth-fRadius}}                  
      Shear_Trans(x,y-z*0.05,z)
      }
    
  #local oBackBasket =
    object {
      oTaperBasket
      clipped_by{plane{-z,-fRadius}}                  
      Shear_Trans(x,y+z*0.05,z)
      }
    
  #local oBasket =
    object {
      union {
        object {oFrontBasket}
        object {oBackBasket}   
        object {Bottle(true) rotate   30*z rotate 15*x scale 12 translate <fWidth/2-1,fHeight/2,fDepth/2>}
        object {Bottle(true) rotate  110*z  scale 12 translate <fWidth  ,fHeight  ,fDepth/4>}
        object {Bottle(true) rotate  -80*z  scale 12 translate <fWidth*.375-1  ,fHeight-1  ,3*fDepth/4>} 
        box{<1,1,1><fWidth-1,fHeight-3,fDepth-1> pigment{White}}
        }  
      texture {tBasketTexture}
      scale 1/12
      }
      
  oBasket
  
#end